/*** prostat 1.32 ***/

/*** output.c; the output functions, obviously. ***/

#include "analhead2.h"
#include <gd.h>
#include "gdfonts.h"




void Goto(FILE *outf)
{
	extern flag dq, hq, mq, Sq, sq, Rq, oq, Pq, tq;
	extern char reportorder[], lang[];
	
	char *ro;
	
	fprintf(outf, "\n<p>\n<div align=\"center\">\n<table align=\"center\" width=\"100%%\" border=\"1\"><tr>");
	fprintf(outf, "\n<td><font size=\"2\"><A HREF=\"#Top\">");
	if(strcmp(lang, "EN") == 0)
    		fprintf(outf, "Top");
    	else
    		fprintf(outf, "Top");
    	fprintf(outf, "</A></font>");
    		
	for (ro = reportorder; *ro != '\0'; ro++) {

    	switch(*ro) {

      
    	case 'd': /* Daily summary */
    		if (dq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Daily\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "Daily report");
    			else
    				fprintf(outf, "Donn&eacute;es journali&egrave;res");
    			fprintf(outf, "</A></font>");
    		}
    		break;

    	case 'h': /* Hourly summary */
    		if (hq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Hourly\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "Hourly report");
    			else
    				fprintf(outf, "Moyennes horaires");
    			fprintf(outf, "</A></font>");
    		}
    		break;
    		
    	case 'D':    /* Domain report */
    		if (oq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Domain\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "Top level domain report");
    			else
    				fprintf(outf, "Top level domain");
    			fprintf(outf, "</A></font>");
    		}
    		break;
    	
    	case 'S':    /* Host report */
    		if (Sq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Host\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "Host report");
    			else
    				fprintf(outf, "Machines clientes");
    			fprintf(outf, "</A></font>");
    		}
    		break;
    	
    	case 'P':   /* Protocol report */
    		if (Pq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Protocol\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "Protocol report");
    			else
    				fprintf(outf, "Protocoles utilis&eacute;s");
    			fprintf(outf, "</A></font>");
    		}
    		break;
    	
    	case 's':    /* Remote sites report */
    		if (sq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Remote sites\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "Remote sites report");
    			else
    				fprintf(outf, "Sites distants");
    			fprintf(outf, "</A></font>");
    		}
    		break;

	case 'R':    /* Requests report */
                if (Rq) {
                        fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Requests\">");
                        if(strcmp(lang, "EN") == 0)
                                fprintf(outf, "Requestss report");
                        else
                                fprintf(outf, "Requ&ecirc;tes");
                        fprintf(outf, "</A></font>");
                }
                break;

    	
    	case 'm' : /* Mime type Report */
    		if (mq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Mime\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "Mime type Report");
    			else
    				fprintf(outf, "Types mime");
    			fprintf(outf, "</A></font>");
    		}
    		break;
    	
    	case 't' : /* File type Report */
    		if (tq) {
    			fprintf(outf, "\n<td align=\"center\"><font size=\"2\"><A HREF=\"#Type\">");
    			if(strcmp(lang, "EN") == 0)
    				fprintf(outf, "File type Report");
    			else
    				fprintf(outf, "Types de fichier");
    			fprintf(outf, "</A></font>");
    		}
    		break;
    	}
    	}
    	fprintf(outf, "</table>\n</div>");

}

void print_add_im(char *type_im, int date, int monthno, int year, int hr, int min, int tvalue[10],  int nvalue, int period, int max_value, int type)
{

        extern char outfile[];

        gdPoint points[4];
        gdImagePtr im;
        FILE *in;
        FILE *out;
        int color;
        int black;
        int grey;
        int white;
        char file[MAXSTRINGLENGTH];
	char s[MAXSTRINGLENGTH];
        int width, height, margex, margey, nbstep, taillex, tailley, i, j, delta, deltay, r, v, b;
        float x1, x2, y1, y2, stepx;
        double x, y, yy, lvalue1, lvalue2, yvalue, yyvalue;

	width = 576;
        height = 200;
        margex=50;
        margey=30;
	taillex = width -2*margex;
        tailley = height -2*margey;
        nbstep=1440/period;
        stepx=(float)(width-2*margex)/1440;

        sprintf(file, "%s/images/%s_%d_%d_%d.gif", outfile, type_im, year, monthno, date);
        in = fopen(file, "rb");
        if (!in) {
                fprintf(stderr,
                        "Creation du fichier %s.\n", file);
		im = gdImageCreate(width, height);
		black = gdImageColorAllocate(im, 0, 0, 0);
                white = gdImageColorAllocate(im, 255, 255, 255);
                grey = gdImageColorAllocate(im, 204, 204, 204);

                x1 = y1 = 0;
                x2 = width - 1;
                y2 = height - 1;
                gdImageFilledRectangle(im, x1, y1, x2, y2, grey);
                gdImageColorTransparent(im, grey);

                x1 = margex;
                x2 = width - margex;
                y1 = height - margey;

                gdImageLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black); 
		x1 = margex;
                j = 0;
                y1 = height - margey;
                y2 = height - margey +2;
        	stepx=(float)(width-2*margex)/24;

                for(i = 0; i <= 23; i++) {
                        gdImageLine(im,  (int)x1, (int)y1, (int)x1, (int)y2, black);
                        if (j == 0) {
                                sprintf(s, "%d", i);
                                gdImageString(im, gdFontSmall, (int)x1-2, (int)y2+1, s, black);
                                j = 1;
                        }
                        else j = 0;
                        x1 = x1 + stepx;
                }
                x = margex + 1;
                y = 10.0;
                sprintf(s, "%d/%d/%d", date, monthno, year);
                gdImageString(im, gdFontSmall, (int)x, (int)y, s, black);
		if(type==1) {
			x = margex/3;
			for(i=1; i<=(int)log10((double)max_value); i++) {
	                        y1 = margey +tailley-tailley*yvalue/log10((double)max_value);
				sprintf(s, "%.0f", y);
                       		gdImageString(im, gdFontSmall, (int)x, (int)y1-5, s, black);
                       		y  = y*10.;
                       		yvalue = log10(y);
                	}
        	}
		else {
			x1 = margex-3;
                	x2 = width - margex;
                	deltay = (int)(tailley/4);
                	delta = (int)(max_value/4);
                	y1 = margey;
                	y = max_value;
                	x = margex/3;
                	for(i=1; i<5; i++) {
                        	gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                        	sprintf(s, "%.0f", y);
                        	gdImageString(im, gdFontSmall, x, (int)y1-5, s, black);
                        	y1 = y1 + deltay;
                        	y = y - delta;
                	}
		}
	}
	else {
        	im = gdImageCreateFromGif(in);
	}
        /* Now load the image. */
        fclose(in);
        if (!im) {
                fprintf(stderr,
                        "Error: %s is not a valid gif file.\n", file);
                exit(1);
        }

	black = gdImageColorExact(im, 0, 0, 0);
        if (black == (-1)) {
        	black = gdImageColorAllocate(im, 0, 0, 0);
        }
        grey = gdImageColorExact(im, 124, 124, 124);
        if (grey == (-1)) {
                grey = gdImageColorAllocate(im, 124, 124, 124);
        } 
        x1=(float)(margex+(60*hr+min)*stepx);
        x2=x1+period*stepx;
	for(i=0; i<2*nvalue;i++) {
		if(type==0) {
			lvalue1=tvalue[i];
			i++;
			lvalue2=tvalue[i];
	        	y1 = margey +tailley-tailley*(float)lvalue1/max_value;
			y2 = margey +tailley-tailley*(float)lvalue2/max_value;
		}
		else {
			if(tvalue[i]>0) 
                                lvalue1=log10((double)tvalue[i]);
                        else
                                lvalue1=0;
                        i++;
                        if(tvalue[i]>0)
                                lvalue2=log10((double)tvalue[i]);
                        else
                                lvalue2=0;
	        	y1 = margey +tailley-tailley*lvalue1/log10((double)max_value);
	        	y2 = margey +tailley-tailley*lvalue2/log10((double)max_value);
		}
	        if((int)y1<0)
	                y1=margey;
	        if((int)y2<0)
			y2=margey;
	        points[0].x = (int)x1;
	        points[0].y = (int)y1;
	        points[1].x = (int)x2;
	        points[1].y = (int)y2;
	        points[2].x = (int)x2;
	        points[2].y = height-margey;
	        points[3].x = (int)x1;
	        points[3].y = height-margey;
		switch(i) {
		case(1) :
			r=255;
			v=b=0;
			break;
		case(3) :
                        b=255;
                        r=v=0;
                        break;
		case(5) :
                        v=255;
                        r=b=0;
                        break;
		}
		
	        color = gdImageColorExact(im, r, v, b);
	        if (color == (-1)) {
	                color = gdImageColorAllocate(im, r, v, b);
	        } 
		if((int)y1 > 0 || (int)y2 > 0) 
	        	gdImageFilledPolygon(im, points, 4, color);
	}
	x1 = margex-3;
        x2 = width - margex;
        x = margex/3;
	if(type==1) {
        	y = 10.;
	        yvalue = log10(y);
        	for(i=1; i<=(int)log10((double)max_value); i++) {
		       y1 = margey +tailley-tailley*yvalue/log10((double)max_value);
	               gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
	               sprintf(s, "%.0f", y);
	               gdImageString(im, gdFontSmall, (int)x, (int)y1-5, s, black);
	               for(j=1; j<=4; j++) {
	                         yy=(y*(j*2))/10;
	                         yyvalue = log10(yy);
	                         y1 = margey +tailley-tailley*yyvalue/log10((double)max_value);
	                         gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, grey);
	               }
	               y  = y*10.;
	               yvalue = log10(y);
	        }
	}
	else {
		deltay = (int)(tailley/4);
        	y1 = margey;
	        y = max_value;
	        for(i=1; i<5; i++) {
	                gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
	                y1 = y1 + deltay;
	        } 
	}

        out = fopen(file, "wb");
        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);



}


void print_mime_size_im(struct mime_types *mimesorthead)
{

        extern int no_mimes;
        extern char firstday[];
        extern char outfile[];
        extern int mimefloor;
        extern int no_mimesort;

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, r, v, i;
	double max_reqs, delta, deltay;
	float x1, x2, y1, y2, stepx;
        struct mime_types *mimep;
        double x, y;
        char file[MAXSTRINGLENGTH];

        width = 200;
        height = 200;
        margex=10;
        margey=10;
        if (mimefloor == 0)
                nbstep = no_mimes;
        else if (mimefloor < 0)
                nbstep = -mimefloor;
        else
                nbstep = no_mimesort;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(width-(2*(float)margex))/nbstep;

        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width - 1;
        y2 = height - 1;
        max_reqs = mimesorthead -> bytes;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

	x = max_reqs;
        delta = 1;
        while(x > 10) {
                x = x/10;
                delta = delta*10;
        }
        x1 = margex-3;
        x2 = width - margex;
        x = tailley;
        y = max_reqs;
	deltay = (x*delta)/y;
        y1 = height - margey - deltay;

        while (y1 > margey) {
                gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }


        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
        for(mimep = mimesorthead; mimep -> name != NULL && i < nbstep;
            mimep = mimep -> next) {
                y1 = margey + tailley - tailley*mimep -> bytes/max_reqs;
                r = 255 - (int)255*mimep -> bytes/max_reqs;
                v = 255-r;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
                x1 += stepx;
                x2 += stepx;
                i++;
        }


        sprintf(file, "%s/images/mime%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);    
        fclose(out);
        gdImageDestroy(im);

}

void print_mime_im(struct mime_types *mimesorthead)
{
        extern int no_mimes;
        extern char firstday[];
        extern char outfile[];
        extern int mimefloor;
        extern int no_mimesort;

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, max_reqs, r, v, i, delta;
	float stepx, x1, x2, y1, y2, deltay;
        struct mime_types *mimep;
        double x, y;
        char file[MAXSTRINGLENGTH];

        width = 200;
        height = 200;
        margex=10;
        margey=10;
        if (mimefloor == 0)
                nbstep = no_mimes;
        else if (mimefloor < 0)
                nbstep = -mimefloor;
        else
                nbstep = no_mimesort;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;

        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width - 1;
        y2 = height - 1;
        max_reqs = mimesorthead -> reqs;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

	x = max_reqs;
        delta = 1;
        while(x > 10) {
                x = x/10;
                delta = delta*10;
        }
        x1 = margex-3;
        x2 = width - margex;
        x = tailley;
        y = max_reqs;
        deltay = x*delta/y;
        y1 = height - margey - deltay;
        while (y1 > margey) {
                gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }

        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
        for(mimep = mimesorthead; mimep -> name != NULL && i < nbstep;
            mimep = mimep -> next) {
                y1 = margey +tailley-tailley*(float)mimep -> reqs/max_reqs;
                r = 255 - (int)255*(float)mimep -> reqs/max_reqs;
                v = 255-r;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
                x1 += stepx;
                x2 += stepx;
                i++;
        }


        sprintf(file, "%s/images/mime%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);    
        fclose(out);
        gdImageDestroy(im);

}

void print_domain_size_im(int firstdom)
{

        extern struct domain *domainhead[];
        extern char firstday[];
        extern char outfile[];
        extern int domfloor;
        extern int no_domsort;
        extern int no_doms;

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, r, i, j;
	float stepx, x1, x2, y1, y2;
	double max_reqs, delta, deltay;
        double x, y;
        char file[MAXSTRINGLENGTH];

        width = 200;
        height = 200;
        margex=10;
        margey=10;
        if (domfloor == 0)
                nbstep = no_doms;
        else if (domfloor < 0)
                nbstep = -domfloor;
        else
                nbstep = no_domsort;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width-1;
        y2 = height-1;
        max_reqs = domainhead[firstdom] -> bytes;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

	x = max_reqs;
        delta = 1;
        while(x > 10) {
                x = x/10;
                delta = delta*10;
        }
        x1 = margex-3;
        x2 = width - margex;
        x = tailley;
        y = max_reqs;
	deltay = x*delta/y;
        y1 = height - margey - deltay;

        while (y1 > margey) {
                gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }


        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        if (domfloor < 0)
          j = domfloor;
        else j = 1;

        for(i  = firstdom; i >=0 && (j++) != 0; i = domainhead[i] -> nexti) {;
                y1 = margey + tailley-tailley*domainhead[i] -> bytes/max_reqs;
                r = 255 - (int)255*domainhead[i] -> bytes/max_reqs;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1,  (int)x2, (int)y2, black);
                x1 += stepx;
                x2 += stepx;

        }

        sprintf(file, "%s/images/domain%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);


}


void print_domain_im(int firstdom)
{

	extern struct domain *domainhead[];
	extern char firstday[];
        extern char outfile[];
	extern int domfloor;
	extern int no_domsort;
	extern int no_doms;
	
	gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, max_reqs, r, i, j, delta;
	float stepx, x1, x2, y1, y2, deltay;
        double x, y;
        char file[MAXSTRINGLENGTH];

        width = 200;
        height = 200;
        margex=10;
        margey=10;
	if (domfloor == 0)
                nbstep = no_doms;
        else if (domfloor < 0)
                nbstep = -domfloor;
        else
                nbstep = no_domsort;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width-1;
	y2 = height-1;
        max_reqs = domainhead[firstdom] -> reqs;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

	x = max_reqs;
        delta = 1;
        while(x > 10) {
                x = x/10;
                delta = delta*10;
        }
        x1 = margex-3;
        x2 = width - margex;
        x = tailley;
        y = max_reqs;
        deltay = x*delta/y;
        y1 = height - margey - deltay;
        while (y1 > margey) {
                gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }

        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
	if (domfloor < 0)
          j = domfloor;
        else j = 1;

        for(i  = firstdom; i >=0 && (j++) != 0; i = domainhead[i] -> nexti) {;
                y1 = margey + tailley-tailley*(float)domainhead[i] -> reqs/max_reqs;
		r = 255 - (int)255*(float)domainhead[i] -> reqs/max_reqs;
		color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, x1, y1, x2, y2, color);
                gdImageRectangle(im, x1, y1, x2, y2, black);
                x1 += stepx;
                x2 += stepx;

        }

	sprintf(file, "%s/images/domain%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);


}

void print_daily_im()
{
	extern char firstday[];
        extern char outfile[];
        extern int  dailyreq[];
	extern char lang[];

	gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, max_reqs, i, r;
	float x1, x2, y1, y2, stepx, cx, cy;
        char file[MAXSTRINGLENGTH];
        char s[3];


        max_reqs=0;
        for (i = 0; i <= 6; i++) {
          if (dailyreq[i] > max_reqs)
            max_reqs = dailyreq[i];
        }
        width = 200;
        height = 200;
        margex=10;
        margey=15;
        nbstep=7;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width - 1;
        y2 = height - 1;
        gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
        gdImageColorTransparent(im, color);

        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
        cx = margex + 1;
        cy = y2 + 2;
        for(i = 0; i <= 6; i++) {
                y1 = margey + tailley-tailley*(float)dailyreq[i]/max_reqs;
		r = 255 - (int)255*(float)dailyreq[i]/max_reqs;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
		if(strcmp(lang, "EN") == 0) {
	                if(i==0) sprintf(s, "Sun");
			else if(i==1) sprintf(s, "Mon");
			else if(i==2) sprintf(s, "Tue");
			else if(i==3) sprintf(s, "Wed");
			else if(i==4) sprintf(s, "Thu");
			else if(i==5) sprintf(s, "Fri");
			else if(i==6) sprintf(s, "Sat");
		}
		else {
			if(i==0) sprintf(s, "Dim");
                	else if(i==1) sprintf(s, "Lun");
                	else if(i==2) sprintf(s, "Mar");
	                else if(i==3) sprintf(s, "Mer");
	                else if(i==4) sprintf(s, "Jeu");
	                else if(i==5) sprintf(s, "Ven");
	                else if(i==6) sprintf(s, "Sam");
		}
                gdImageString(im, gdFontSmall, (int)cx, (int)cy, s, black);
                cx = cx + stepx;
                x1 += stepx;
                x2 += stepx;

        }

        sprintf(file, "%s/images/daily%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);

}

void print_daily_size_im()
{
        extern char firstday[];
        extern char outfile[];
        extern double  dailysize[];
	extern char lang[];

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, i, r;
	double max_reqs;
	float x1, x2, y1, y2, cx, cy, stepx;
        char file[MAXSTRINGLENGTH];
        char s[3];


        max_reqs=0;
        for (i = 0; i <= 6; i++) {
          if (dailysize[i] > max_reqs)
            max_reqs = dailysize[i];
        }
        width = 200;
        height = 200;
        margex=10;
        margey=15;
        nbstep=7;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width - 1;
        y2 = height - 1;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
        cx = margex + 1;
        cy = y2 + 2;
        for(i = 0; i <= 6; i++) {
                y1 = margey + (tailley-(tailley*(dailysize[i]/max_reqs)));
                r = 255 - (int)255*dailysize[i]/max_reqs;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
		if(strcmp(lang, "EN") == 0) {
                        if(i==0) sprintf(s, "Sun");
                        else if(i==1) sprintf(s, "Mon");
                        else if(i==2) sprintf(s, "Tue");
                        else if(i==3) sprintf(s, "Wed");
                        else if(i==4) sprintf(s, "Thu");
                        else if(i==5) sprintf(s, "Fri");
                        else if(i==6) sprintf(s, "Sat");
                }
                else {
                        if(i==0) sprintf(s, "Dim");
                        else if(i==1) sprintf(s, "Lun");
                        else if(i==2) sprintf(s, "Mar");
                        else if(i==3) sprintf(s, "Mer");
                        else if(i==4) sprintf(s, "Jeu");
                        else if(i==5) sprintf(s, "Ven");
                        else if(i==6) sprintf(s, "Sam");
                }
                gdImageString(im, gdFontSmall, cx, cy, s, black);
		cx = cx + stepx;
                x1 += stepx;
                x2 += stepx;

        }

        sprintf(file, "%s/images/daily_size%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);

}

void print_hours_size_im()
{

        extern char firstday[];
        extern char outfile[];
        extern double hourlysize[];

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, i, j, r;
	float stepx, x1, x2, y1, y2, cx, cy;
	double max_reqs;
        char file[MAXSTRINGLENGTH];
        char s[3];


        max_reqs=0;
        for (i = 0; i <= 23; i++) {
          if (hourlysize[i] > max_reqs)
            max_reqs = hourlysize[i];
        }
        width = 300;
        height = 200;
        margex=10;
        margey=15;
        nbstep=24;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width - 1;
        y2 = height - 1;
        gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
        gdImageColorTransparent(im, color);

        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
        cx = margex + 1;
        cy = y2 + 2;
	j = 0;
        for(i = 0; i <= 23; i++) {
                y1 = margey + tailley-tailley*hourlysize[i]/max_reqs;
                r = 255 - (int)255*hourlysize[i]/max_reqs;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
		if (j == 0) {
                	sprintf(s, "%d", i);
	                gdImageString(im, gdFontSmall, (int)cx, (int)cy, s, black);
			j = 1;
		}
		else j = 0;
                cx = cx + stepx;
                x1 += stepx;
                x2 += stepx;

        }
        sprintf(file, "%s/images/hourly_size%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);

}



void print_hours_im()
{
	
	extern char firstday[];
        extern char outfile[];
	extern int hourlyreq[];

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, max_reqs, i, j, r;
	float stepx, x1, x2, y1, y2, cx, cy;
        char file[MAXSTRINGLENGTH];
        char s[3];


	max_reqs=0;
	for (i = 0; i <= 23; i++) {
          if (hourlyreq[i] > max_reqs)
            max_reqs = hourlyreq[i];
	}
	width = 300;
        height = 200;
        margex=10;
        margey=15;
        nbstep=24;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width - 1;
	y2 = height - 1;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);
	
	x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
	cx = margex + 1;
	cy = y2 + 2;
        j = 0;
	for(i = 0; i <= 23; i++) {
                y1 = margey + tailley-tailley*(float)hourlyreq[i]/max_reqs;
		r = 255 - (int)255*(float)hourlyreq[i]/max_reqs;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
		if ( j == 0 ) {
			sprintf(s, "%d", i);
			gdImageString(im, gdFontSmall, (int)cx, (int)cy, s, black);
			j = 1;
		}
		else j = 0;
		cx = cx + stepx;
                x1 += stepx;
                x2 += stepx;

        }
	sprintf(file, "%s/images/hourly%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);

}

void print_remote_host_size_im(struct url *urlsorthead)
{
        extern char firstday[];
        extern char outfile[];
        extern int sitesfloor;
        extern int no_reqsort;
        extern int no_urls;


        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, r, i;
	double max_reqs, delta, deltay;
	float stepx, x1, x2, y1, y2;
        struct url *urlp;
        double x, y;
        char file[MAXSTRINGLENGTH];

        width = 200;
        height = 200;
        margex=10;
        margey=10;
        if (sitesfloor == 0)
                nbstep = no_urls;
        else if (sitesfloor < 0)
                nbstep = -sitesfloor;
        else
                nbstep = no_reqsort;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width-1;
        y2 = height - 1;
        max_reqs = urlsorthead -> bytes;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

	x = max_reqs;
        delta = 1;
        while(x > 10) {
                x = x/10;
                delta = delta*10;
        }
        x1 = margex-3;
        x2 = width - margex;
        x = tailley;
        y = max_reqs;
	deltay = x*delta/y;
        y1 = height - margey - deltay;

        while (y1 > margey) {
                gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }



        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
        for(urlp = urlsorthead; urlp -> name != NULL && i < nbstep;
            urlp = urlp -> next) {
                y1 = margey + tailley-tailley*urlp -> bytes/max_reqs;
                r = 255 - (int)255*urlp -> bytes/max_reqs;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
                x1 += stepx;
                x2 += stepx;
                i++;

        }


        sprintf(file, "%s/images/remote_host%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);

}


void print_remote_host_im(struct url *urlsorthead)
{
        extern char firstday[];
        extern char outfile[];
	extern int sitesfloor;
	extern int no_reqsort;
	extern int no_urls;
	

	gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, max_reqs, r, i, delta;
	float stepx, x1, x2, y1, y2, deltay;
        struct url *urlp;
	double x, y;
        char file[MAXSTRINGLENGTH];

	width = 200;
        height = 200;
        margex=10;
	margey=10;
	if (sitesfloor == 0)
                nbstep = no_urls;
        else if (sitesfloor < 0)
                nbstep = -sitesfloor;
        else
                nbstep = no_reqsort;
	taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;
	im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width-1;
	y2 = height - 1;
	max_reqs = urlsorthead -> reqs;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

	x = max_reqs;
        delta = 1;
        while(x > 10) {
                x = x/10;
                delta = delta*10;
        }
        x1 = margex-3;
        x2 = width - margex;
        x = tailley;
        y = max_reqs;
        deltay = x*delta/y;
        y1 = height - margey - deltay;
        while (y1 > margey) {
                gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }

	
	x1=margex;
        x2=x1+stepx;
        y2=height-margey;
	i = 0;
        for(urlp = urlsorthead; urlp -> name != NULL && i < nbstep;
            urlp = urlp -> next) {
                y1 = margey + tailley-tailley*(float)urlp -> reqs/max_reqs;
		r = 255 - (int)255*(float)urlp -> reqs/max_reqs;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
                x1 += stepx;
                x2 += stepx;
                i++;

        }


        sprintf(file, "%s/images/remote_host%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);
        fclose(out);
        gdImageDestroy(im);

}

void print_host_size_im(struct host *hostsorthead)
{
        extern int no_hosts;
        extern char firstday[];
        extern char outfile[];
        extern int hostfloor;
        extern int no_hostsort;

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
        int width, height, margex, margey, nbstep, taillex, tailley, r, v, i;
	float stepx, x1, x2, y1, y2;
	double max_reqs, delta, deltay;
        struct host *hostp;
        double  x, y;
        char file[MAXSTRINGLENGTH];

        width = 200;
        height = 200;
        margex=10;
        margey=10;
        if (hostfloor == 0)
                nbstep = no_hosts;
        else if (hostfloor < 0)
                nbstep = -hostfloor;
        else
                nbstep = no_hostsort;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;

        im = gdImageCreate(width, height);
        black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
        x1 = y1 = 0;
        x2 = width - 1;
        y2 = height - 1;
        max_reqs = hostsorthead -> bytes;
        gdImageFilledRectangle(im, x1, y1, x2, y2, color);
        gdImageColorTransparent(im, color);

        x = max_reqs;
	delta = 1;
	while(x > 10) {
		x = x/10;
		delta = delta*10;
	}
        x1 = margex-3;
        x2 = width - margex;
        x = tailley;
        y = max_reqs;
        deltay = x*delta/y;
        y1 = height - margey - deltay;

        while (y1 > margey) {
                gdImageDashedLine(im, (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }


        x1=margex;
        x2=x1+stepx;
        y2=height-margey;
        i = 0;
        for(hostp = hostsorthead; hostp -> name != NULL && i < nbstep;
            hostp = hostp -> next) {
                y1 = margey + tailley - tailley*hostp -> bytes/max_reqs;
                r = 255 - (int)255*hostp -> bytes/max_reqs;
                v = 255-r;
                color = gdImageColorAllocate(im, 255, r, r);
                gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
                gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
                x1 += stepx;
                x2 += stepx;
                i++;
        }


        sprintf(file, "%s/images/host%s.gif", outfile, firstday);
        out = fopen(file, "wb");

        gdImageGif(im, out);    
        fclose(out);
        gdImageDestroy(im);

}



void print_host_im(struct host *hostsorthead)
{
	extern int no_hosts;
	extern char firstday[];
	extern char outfile[];
	extern int hostfloor;
	extern int no_hostsort;

        gdImagePtr im;
        FILE *out;
        int black;
        int white;
        int color;
	int width, height, margex, margey, nbstep, taillex, tailley, max_reqs, r, v, i, delta;
	float stepx, x1, x2, y1, y2, deltay;
	struct host *hostp;
	double x, y;
	char file[MAXSTRINGLENGTH];

	width = 200;
        height = 200;
        margex=10;
        margey=10;
	if (hostfloor == 0)
		nbstep = no_hosts;
	else if (hostfloor < 0)
		nbstep = -hostfloor;
	else
		nbstep = no_hostsort;
        taillex = width -2*margex;
        tailley = height -2*margey;
        stepx=(float)(width-2*margex)/nbstep;

	im = gdImageCreate(width, height);
	black = gdImageColorAllocate(im, 0, 0, 0);
        white = gdImageColorAllocate(im, 255, 255, 255);
        color = gdImageColorAllocate(im, 204, 204, 204);
	x1 = y1 = 0;
	x2 = width - 1;
	y2 = height - 1;
	max_reqs = hostsorthead -> reqs;
	gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
	gdImageColorTransparent(im, color);

	x = max_reqs;
        delta = 1;
        while(x > 10) {
                x = x/10;
                delta = delta*10;
        }
	x1 = margex-3;
        x2 = width - margex;
	x = tailley;
	y = max_reqs;
        deltay = (int)(x*delta)/y;
        y1 = height - margey - deltay;
        while (y1 > margey) {
		gdImageDashedLine(im,  (int)x1, (int)y1, (int)x2, (int)y1, black);
                y1 = y1 - deltay;
        }
	
	x1=margex;
        x2=x1+stepx;
        y2=height-margey;
	i = 0;
	for(hostp = hostsorthead; hostp -> name != NULL && i < nbstep;
            hostp = hostp -> next) {
                y1 = margey +tailley-tailley*(float)hostp -> reqs/max_reqs;
		r = 255 - (int)255*(float)hostp -> reqs/max_reqs;
		v = 255-r;
		color = gdImageColorAllocate(im, 255, r, r);
		gdImageFilledRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, color);
		gdImageRectangle(im, (int)x1, (int)y1, (int)x2, (int)y2, black);
                x1 += stepx;
                x2 += stepx;
		i++;
        }

	
	sprintf(file, "%s/images/host%s.gif", outfile, firstday);
	out = fopen(file, "wb");

        gdImageGif(im, out);    
        fclose(out);
        gdImageDestroy(im);

}

void print_general(FILE *outf)
{

  extern char *reversehostname();   /* in alias.c */
  extern int minsbetween();         /* in utilities.c */
  extern void int3printf();         /* in utilities.c */
  extern void double3printf();      /* in utilities.c */
  extern int tcp_reqs, udp_reqs;
  extern double tcp_size, udp_size;
  extern flag xq, Sq, sq;
  extern int total_succ_reqs;
  extern int total_reqs, req_hit;
  extern double req_hit_size;
  extern double total_bytes;
  extern char lang[];  
  extern char hostname[];  
  extern char background[];
  extern char hosturl[];
  extern char headerfile[];
  extern struct timestruct firsttime, lasttime;
  extern char monthname[12][4];
  extern int no_urls, no_hosts;
  extern char commandname[];

  extern int totalmins;    /* between first and last entries analysed */
  FILE *tempf;
  char tempstr[MAXSTRINGLENGTH];

  
    
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf,
	    "<html>\n<head><title>Server Statistics for %s</title></head>\n",
	   hostname);
    else
    	fprintf(outf,
	    "<html>\n<head><title>Statistiques pour le  %s</title></head>\n",
	   hostname);
    
    totalmins = minsbetween(firsttime.date, firsttime.monthno, firsttime.year,
                              firsttime.hr, firsttime.min,
                              lasttime.date, lasttime.monthno, lasttime.year,
                              lasttime.hr, lasttime.min) + 1;
    fprintf(outf, "<body");
    if (strcmp(background, "none") != 0)
      fprintf(outf, " background=\"%s\"", background);
    fprintf(outf, ">\n<h1><a NAME=\"Top\">");
    if (hosturl[0] == '-')
      if(strcmp(lang, "EN") == 0) 
      	fprintf(outf, "Server Statistics</a> for %s</h1>\n\n", hostname);
      else
      	fprintf(outf, "Statistiques pour le</a> %s</h1>\n\n", hostname);
    else {
      if(strcmp(lang, "EN") == 0) 
      	fprintf(outf,
	      "Server Statistics</a> for <a HREF=\"%s\">%s</a></h1>\n\n",
	      hosturl, hostname);
      else
      	fprintf(outf,
	      "Statistiques</a> pour le <a HREF=\"%s\">%s</a></h1>\n\n",
	      hosturl, hostname);
    }
    
  /* insert header file */

  headerfile[MAXSTRINGLENGTH - 5] = '\0';  /* for safety */

  if (strcmp(headerfile, "none") != 0) {
    if ((tempf = fopen(headerfile, "r")) == NULL) {
      fprintf(stderr,
	      "%s: Warning: Failed to open headerfile %s: ignoring it.\n",
	      commandname, headerfile);
    }
    else {  /* can open header file */
	fprintf(outf, "<hr>");

      while(fgets(tempstr, MAXLINELENGTH, tempf) != NULL)
	fprintf(outf, "%s", tempstr);
      fclose(tempf);
      if (tempstr[strlen(tempstr) - 1] != '\n')
	fprintf(outf, "\n");

      fprintf(outf, "\n");

    }
  }

  /* Summary statistics */
fprintf(stderr, "Summary statistics\n");
  if (xq) {


  
    if (total_succ_reqs > 0) {
      if(strcmp(lang, "EN") == 0)
      	fprintf(outf,
	      "<b>Statistics from %s %02d %02d %02d:%02d to %s %02d %d %02d:%02d\n  (%.1f days).</b>\n\n",
	     monthname[firsttime.monthno], firsttime.date, firsttime.year,
	     firsttime.hr, firsttime.min,
	     monthname[lasttime.monthno], lasttime.date, lasttime.year,
	     lasttime.hr, lasttime.min,
	     (double)totalmins / 1440.0);
      else
      	fprintf(outf,
	     "<b>P&eacute;riode  : %02d %s %02d %02d:%02d -&gt; %02d %s %d %02d:%02d\n  (%.1f jours).</b>\n\n",
	     firsttime.date, monthname[firsttime.monthno], firsttime.year,
	     firsttime.hr, firsttime.min,
	     lasttime.date, monthname[lasttime.monthno], lasttime.year,
	     lasttime.hr, lasttime.min,
	     (double)totalmins / 1440.0);
    }

    fprintf(outf, "\n");
    Goto(outf);
    fprintf(outf, "<hr>\n<h2>");
    if(strcmp(lang, "EN") == 0)
     	fprintf(outf, "General report");
    else
    	fprintf(outf, "Donn&eacute;es g&eacute;n&eacute;rales");
    
    fprintf(outf, "</h2>\n");
    fprintf(outf, "<p>\n<div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n<tr><td><b>");
    
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Hit requests Percent ");
    else
    	fprintf(outf, "Taux de succ&egrave;s en nombre de requ&ecirc;tes ");
    	
    fprintf(outf, "</b> <td align=\"right\">");
    if(tcp_reqs>0)
	    fprintf(outf, "%.2f%%", (double)req_hit*100/tcp_reqs);
    else
	    fprintf(outf, "0%%");

    fprintf(outf, "\n<tr><td><b>");
    
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Hit bytes Percent ");
    else
    	fprintf(outf, "Taux de succ&egrave;s en nombre d'octets ");
    fprintf(outf, "</b> <td align=\"right\"> ");
    if(tcp_size>0)
	    fprintf(outf, "%.2f%%", req_hit_size*100/tcp_size);
    else
	    fprintf(outf, "0%%");

    fprintf(outf, "\n<tr>\n<tr>");

    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total number of requests");
    else
    	fprintf(outf, "Nombre total de requ&ecirc;tes");
    fprintf(outf, "</b> <td align=\"right\">");
    int3printf(outf, total_reqs);

    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total number of successfull requests");
    else
    	fprintf(outf, "Nombre total de requ&ecirc;tes satisfaites");
    fprintf(outf, "</b> <td align=\"right\">");
    int3printf(outf, total_succ_reqs);

    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total number of hit requests :");
    else
    	fprintf(outf, "Requ&ecirc;tes satisfaites par le cache :");
    fprintf(outf, "</b> <td align=\"right\">");
    int3printf(outf, req_hit);

    if (totalmins > 30) {
	fprintf(outf, "\n<tr><td><b>");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Average number of requests per day");
	else
		fprintf(outf, "Nombre moyen de requ&ecirc;tes par jour");
	fprintf(outf, "</b> <td align=\"right\">");
      if (total_reqs < 2 || totalmins <= 0)
	fprintf(outf, "0");
      else
	double3printf(outf,
		      ((double)(total_reqs - 1)) * 1440.0 / (totalmins + 0.0));
    }
    
    if (sq) {   /* These data are not collected o/wise */
	fprintf(outf, "\n<tr><td><b>");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Number of distinct sites accessed");
	else
		fprintf(outf, "Nombres de sites distants acc&eacute;d&eacute;s");
	fprintf(outf, "</b> <td align=\"right\">");
      int3printf(outf, no_urls);
    }
    
    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total bytes");
    else
	fprintf(outf, "Nombre total d'octets transmis");
    fprintf(outf, "</b> <td align=\"right\">");
    double3printf(outf, total_bytes);
    
    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total number of hit bytes :");
    else
    	fprintf(outf, "Nombre d'octets transmis par le cache :");
    fprintf(outf, "</b> <td align=\"right\">");
    double3printf(outf, req_hit_size);

    if (totalmins > 30) {

      fprintf(outf, "\n<tr><td><b>");
      if(strcmp(lang, "EN") == 0)
	fprintf(outf, "Average bytes transferred per day");
      else
	fprintf(outf, "Nombre moyen d'octets transmis par jour");
      fprintf(outf, "</b> <td align=\"right\">");
      if (totalmins <= 0)
	fprintf(outf, "0");
      else
      	double3printf(outf, (total_bytes * 1440) / (totalmins + 0.0));
    }
    
    
    if (Sq) {
      fprintf(outf, "\n<tr><td><b>");
      if(strcmp(lang, "EN") == 0)
      	fprintf(outf, "Number of distinct hosts served");
      else
      	fprintf(outf, "Nombre de machines utilisant ce cache");
      fprintf(outf, "</b> <td align=\"right\">");
      int3printf(outf, no_hosts);
    }

    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total  requests");
    else
    	fprintf(outf, "Nombre de requ&ecirc;tes TCP");
    fprintf(outf, "</b> <td align=\"right\">");
    int3printf(outf, tcp_reqs);

    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total UDP requests");
    else
    	fprintf(outf, "Nombre de requ&ecirc;tes UDP");
    fprintf(outf, "</b> <td align=\"right\">");
    int3printf(outf, udp_reqs);

    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total  bytes");
    else
    	fprintf(outf, "Nombre d'octets TCP");
    fprintf(outf, "</b> <td align=\"right\">");
    double3printf(outf, tcp_size);

    fprintf(outf, "\n<tr><td><b>");
    if(strcmp(lang, "EN") == 0)
    	fprintf(outf, "Total UDP bytes");
    else
    	fprintf(outf, "Nombre d'octets UDP");
    fprintf(outf, "</b> <td align=\"right\">");
    double3printf(outf, udp_size);

    if(tcp_reqs>0) {
    	fprintf(outf, "\n<tr><td><b>");
	if(strcmp(lang, "EN") == 0)
	    fprintf(outf, "Average size of objects (KB)");
	else
	   fprintf(outf, "Taille moyenne des objets (KB)");
    	fprintf(outf, "</b> <td align=\"right\">");
    	fprintf(outf, "%.0f", (tcp_size/1024)/tcp_reqs);
    }
    
    fprintf(outf, "\n</table>\n</div>\n<p>\n");

    
  }   /* end if xq */
  
}

void print_daily(FILE *outf)
{
	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
  	extern char firstday[];
  	extern flag Gq;
	extern char lang[];  
  	extern int dailyreq[];
  	extern double dailysize[];

	int i;
  	char jour_semaine[10];


  	fprintf(stderr, "Daily summary\n");
  	fprintf(outf, "\n\n<hr>\n<h2><a NAME=\"Daily\">");
  	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Daily report");
  	else
		fprintf(outf, "Donn&eacute;es journali&egrave;res");
  	fprintf(outf, "</a></h2>\n");

	if(Gq) {
                print_daily_im();
	        print_daily_size_im();
	}
	fprintf(outf, "\n<p>\n<div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n");
	if(Gq) {
		fprintf(outf, "<tr><th><th>");
		if(strcmp(lang, "EN") == 0)
			fprintf(outf, "Days");
		else
			fprintf(outf, "Jours");
		fprintf(outf, "<th>#reqs<th>#bytes\n");
	        fprintf(outf, "\n<tr><td rowspan=\"7\" valign=\"middle\"><b>");
	        if(strcmp(lang, "EN") == 0)
	                fprintf(outf, "Requests :");
	        else
	                fprintf(outf, "Requ&ecirc;tes :");
	        fprintf(outf, "</b><blockquote><img src=\"images/daily%s.gif\"></blockquote><hr><b>", firstday);
	        if(strcmp(lang, "EN") == 0)
	                fprintf(outf, "Bytes :");
	        else
	                fprintf(outf, "Octets :");
	        fprintf(outf, "</b><blockquote><img src=\"images/daily_size%s.gif\"></blockquote>", firstday);
	}
	else {
		fprintf(outf, "<tr><th>");
		if(strcmp(lang, "EN") == 0)
			fprintf(outf, "Days");
		else
			fprintf(outf, "Jours");
		fprintf(outf, "<th>#reqs<th>#bytes\n");
		fprintf(outf, "\n<tr>");
	}
	for (i = 0; i <= 6; i++) {
		if(i !=0) fprintf(outf, "\n<tr>");
		if(strcmp(lang, "EN") == 0) {
			if(i==0)sprintf(jour_semaine, "Sunday");
			else if(i==1)sprintf(jour_semaine, "Monday");
			else if(i==2)sprintf(jour_semaine, "Tuesday");
			else if(i==3)sprintf(jour_semaine, "Wednesday");
			else if(i==4)sprintf(jour_semaine, "Thursday");
			else if(i==5)sprintf(jour_semaine, "Friday");
			else if(i==6)sprintf(jour_semaine, "Saturday");
		}
		else {
			if(i==0)sprintf(jour_semaine, "Dimanche");
			else if(i==1)sprintf(jour_semaine, "Lundi");
			else if(i==2)sprintf(jour_semaine, "Mardi");
			else if(i==3)sprintf(jour_semaine, "Mercredi");
			else if(i==4)sprintf(jour_semaine, "Jeudi");
			else if(i==5)sprintf(jour_semaine, "Vendredi");
			else if(i==6)sprintf(jour_semaine, "Samedi");
		}

		fprintf(outf, "\n<td>%s<td align=\"right\">%d<td align=\"right\">", jour_semaine, dailyreq[i]);
		double3printf(outf, dailysize[i]);
	}
	fprintf(outf, "\n</table></div>\n<p>\n");
	Goto(outf);

}


void print_hourly(FILE *outf)
{

	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
  	extern char firstday[];
  	extern flag Gq;
	extern char lang[];  
  	extern int hourlyreq[];
  	extern double hourlysize[];
	extern totalmins;

	int i;

	fprintf(stderr, "hourly summary\n");
	fprintf(outf,"\n\n<hr>\n<h2><a NAME=\"Hourly\">");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf,"  Hourly report");
	else
	  	fprintf(outf,"  Moyennes horaires");
	fprintf(outf,"</a></h2>\n");

	if(Gq) {
		print_hours_im();
		print_hours_size_im();
	}
	fprintf(outf, "\n<p>\n<div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n");
	if(Gq) {
                fprintf(outf, "<tr><th><th>");
                if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "Hours");
                else
                	fprintf(outf, "Heures");
                fprintf(outf, "<th>#reqs<th>#bytes\n");
                fprintf(outf, "\n<tr><td rowspan=\"24\" valign=\"middle\"><b>");
                if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "Requests :");
                else
                	fprintf(outf, "Requ&ecirc;tes :");
                fprintf(outf, "</b><blockquote><img src=\"images/hourly%s.gif\"></blockquote><b>", firstday);
                if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "Bytes :");
                else
                	fprintf(outf, "Octets :");
                fprintf(outf, "</b><blockquote><img src=\"images/hourly_size%s.gif\"></blockquote>", firstday);
	}
	else {
                fprintf(outf, "<tr><th>");
                if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "Hours");
                else
                	fprintf(outf, "Heures");
                fprintf(outf, "<th>#reqs<th>#bytes\n");
		fprintf(outf, "\n<tr>");
	}
        for (i = 0; i <= 23; i++) {
                if(i !=0) fprintf(outf, "\n<tr>");
		if(totalmins > 1440) {
                	fprintf(outf, "\n<td align=\"center\">%dh<td align=\"right\">%d<td align=\"right\">", i, (int)(hourlyreq[i]/(totalmins / 1440.0)));
			double3printf(outf, hourlysize[i]/(totalmins / 1440.0));
		}
		else {
                	fprintf(outf, "\n<td align=\"center\">%dh<td align=\"right\">%d<td align=\"right\">", i, hourlyreq[i]);
			double3printf(outf, hourlysize[i]);
		}
			
        }
        fprintf(outf, "\n</table>\n</div>\n<p>\n");
        Goto(outf);
    

}

void print_domain(FILE *outf, int firstdom)
{
	
	extern struct domain *domainhead[];
  	extern int no_domsort;
	extern int no_doms;
 	extern int subonumber;
 	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
  	extern char firstday[];
  	extern flag Gq;
  	extern int total_succ_reqs;
	extern double total_bytes;
	extern char lang[];  
 	extern int domsortby;
  	extern int domfloor;
	extern char domcols[];

	
	double pc;
	int pc1, pc2;   /* the %age of bytes or reqs for a particular entry */
	int i, j, nbstep;
	char *cols;

	fprintf(stderr, "Domain report\n");
	fprintf(outf,"\n\n<hr>\n<h2><a NAME=\"Domain\">");
	if(strcmp(lang, "EN") == 0)
	  	fprintf(outf,"Top level domain report");
	else
	  	fprintf(outf,"Top level domain acc&eacute;d&eacute;s");
	fprintf(outf,"</a></h2>\n\n");
	
	fprintf(outf, "<p>");
	if (domfloor < 0) {
	  if (domfloor == -1)
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the first domain, ");
	    else
	    	fprintf(outf, "Le premier domaine, ");
	  else
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the %d first domains, ", -domfloor);
	    else
	    	fprintf(outf, "Les %d premiers domaines, ", -domfloor);
	}
	else {
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "Printing all domains, ");
	  else
	  	fprintf(outf, "Tous les domaines, ");
	  if (domsortby == BYBYTES) {
	    if (domfloor != 0)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, "with at least %d.%02d%% of the traffic, ",
		      domfloor / 100, domfloor % 100);
	      else
	      	fprintf(outf, "avec au moins %d.%02d%% du trafic total, ",
		      domfloor / 100, domfloor % 100);
	  }
	  else   /* domsortby REQUESTS */
	    if (domfloor > 0)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, "with at least %d request%s, ", domfloor,
		     (domfloor == 1)?"":"s");
	      else
	      	fprintf(outf, "avec au moins %d requ&ecirc;te%s, ", domfloor,
		     (domfloor == 1)?"":"s");
	}   
	if (domsortby == BYREQUESTS)
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "sorted by number of requests.");
	  else
	  	fprintf(outf, "class&eacute;s par le nombre de requ&ecirc;tes.");
	else
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "sorted by amount of traffic.");
	  else
	  	fprintf(outf, "class&eacute;s par le nombre d'octets.");
	if(Gq) {
                if(domsortby == BYREQUESTS)
                        print_domain_im(firstdom);
                else
                        print_domain_size_im(firstdom);
          }
	  fprintf(outf, "\n<p>\n<div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n");

	if(Gq) 
		fprintf(outf, "<tr><th><th>");
	else
		fprintf(outf, "<tr><th>");
		
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Domains\n");
	else
		fprintf(outf, "Domaines\n");
	
	for (cols = domcols; *cols != '\0'; cols++) {
	  switch(*cols) {
	  case 'R':
	    if (subonumber > 0)
	      fprintf(outf, "<th> #reqs");
	    else
	      fprintf(outf, "<th>#reqs");
	    break;
	  case 'r':
	    if (subonumber > 0)
	      fprintf(outf, "<th>  %%reqs");
	    else
	      fprintf(outf, "<th> %%reqs ");
	    break;
	  case 'B':
	      if (subonumber > 0)
		fprintf(outf, "<th> #bytes");
	      else
		fprintf(outf, "<th>#bytes");
	    break;
	  case 'b':
	      if (subonumber > 0)
		fprintf(outf, "<th>%%bytes");
	      else
		fprintf(outf, "<th>%%bytes");
	    break;
	  }
	}
	fprintf(outf, "<th>#reqs_hit ");
        fprintf(outf, "<th>%%reqs_hit ");
        fprintf(outf, "<th>#bytes_hit ");
        fprintf(outf, "<th>%%bytes_hit ");


	if (domfloor == 0)
                nbstep = no_doms;
        else if (domfloor < 0)
                nbstep = -domfloor;
        else
                nbstep = no_domsort;
	if(Gq) 	
		fprintf(outf, "<tr><td rowspan=\"%d\" valign=\"middle\"> <img src=\"images/domain%s.gif\">", nbstep, firstday);
	else
		fprintf(outf, "<tr>");

	if (domfloor < 0) 
	  j = domfloor;
	else j = 1;


	for (i = firstdom; i >= 0 && (j++) != 0 && domainhead[i] -> reqs > 0; i = domainhead[i] -> nexti) {
	  if( i != firstdom ) fprintf(outf, "\n<tr>");
	  
	  if (!(i == DOMHASHSIZE - 2 &&
		((domainhead[i] -> reqs < domfloor && domsortby != BYBYTES) ||
		 (domsortby == BYBYTES && domainhead[i] -> reqs == 0) ||
		 (domsortby == BYBYTES &&
		  domainhead[i] -> bytes / (total_bytes / 10000) < domfloor))))
	    {

              if (domainhead[i] -> id[0] == '*')
                                /* flagged domains, not real domain names */
                fprintf(outf, "\n<td>[%s]\n", domainhead[i] -> name);
              else if (domainhead[i] -> name[0] == '?')
                                /* real domain, but don't print name */
                fprintf(outf, "\n<td>.%s\n", domainhead[i] -> id);
              else
                fprintf(outf, "\n<td>.%s (%s)\n", domainhead[i] -> id, domainhead[i] -> name);

	      for (cols = domcols; *cols != '\0'; cols++) {
		switch(*cols) {
		case 'R':
		    fprintf(outf, "<td align=\"right\"> ");
		    int3printf(outf, domainhead[i] -> reqs);
		  break;
		case 'r':
		  pc = (domainhead[i] -> reqs + 0.0) / 
		    ((total_succ_reqs + 0.0) / 10000);
		  pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
		  pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
		  if (pc1 == 100)
		    fprintf(outf, "<td align=\"right\">  100%%");
		  else if (pc1 > 0 || pc2 > 0)
		    fprintf(outf, "<td align=\"right\">%2d.%02d%%", pc1, pc2);
		  else
		    fprintf(outf, "<td align=\"right\">      ");
		  break;
		case 'B':
		      fprintf(outf, "<td align=\"right\"> ");
		      double3printf(outf, domainhead[i] -> bytes);
		  break;
		case 'b':
		    pc = domainhead[i] -> bytes / (total_bytes / 10000);
		    pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
		    pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */
		    if (pc1 == 100)
		      fprintf(outf, "<td align=\"right\">  100%%");
		    else if (pc1 > 0 || pc2 > 0)
		      fprintf(outf, "<td align=\"right\">%2d.%02d%%", pc1, pc2);
		    else
		      fprintf(outf, "<td align=\"right\">      ");
		  break;
		}
	      }
	      fprintf(outf, "<td align=\"right\"> ");
                  int3printf(outf, domainhead[i]-> reqs_hit);
                  if(domainhead[i] -> reqs>0) {
                          pc = (domainhead[i] -> reqs_hit + 0.0) / ((domainhead[i] -> reqs + 0.0) / 10000);
                          pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
                          pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
                          if(pc1 >= 85)
                                fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
                          else if(pc1 >= 70)
                                fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
                          else if(pc1 >= 55)
                                fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
                          else if(pc1 >= 40)
                                fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
                          else if(pc1 >= 25)
                                fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
                          else
                                fprintf(outf, "<td align=\"right\">");
                          if (pc1 == 100)
                                fprintf(outf, "  100%% ");
                          else if (pc1 > 0 || pc2 > 0)
                                fprintf(outf, "%2d.%02d%% ", pc1, pc2);
                  }


                  fprintf(outf, "<td align=\"right\"> ");
                  double3printf(outf, domainhead[i]-> bytes_hit);

                  if(domainhead[i] -> bytes > 0) {
                    pc = (domainhead[i] -> bytes_hit + 0.0) / ((domainhead[i] -> bytes + 0.0) / 10000);
                    pc1 = ((int)(pc + 0.5)) / 100;
                    pc2 = ((int)(pc + 0.5)) % 100;
                    if(pc1 >= 85)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
                    else if(pc1 >= 70)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
                    else if(pc1 >= 55)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
                    else if(pc1 >= 40)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
                    else if(pc1 >= 25)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
                    else
                        fprintf(outf, "<td align=\"right\">");
                    if (pc1 == 100)
                        fprintf(outf, "  100%% ");
                    else if (pc1 > 0 || pc2 > 0)
                        fprintf(outf, "%2d.%02d%% ", pc1, pc2);
                  }
                  else {
                        fprintf(outf, "<td align=\"right\">");
                  }

	    }

	}   /* end for (i = running over domains) */

	  fprintf(outf, "\n</table>\n</div><p>\n");
	  Goto(outf);
	
}


void print_host(FILE *outf, struct host *hostsorthead)
{
  	extern int no_hostsort;
 	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
  	extern char firstday[];
  	extern flag Gq;
	extern int total_reqs;
	extern double total_bytes;
	extern char lang[];  
	extern int no_hosts;
 	extern int hostsortby;
  	extern int hostfloor;
	extern char hostcols[];
	extern flag neighbours;


	double pc;
	int pc1, pc2;   /* the %age of bytes or reqs for a particular entry */
	int i, j, nbstep;
	char *cols;
	const char *addrp;
  	unsigned long addr;
  	struct hostent *tempp;
	struct host *hostp;

	fprintf(stderr, "Host report\n");
	if(Gq) {
		if(hostsortby == BYREQUESTS)
			print_host_im(hostsorthead);
		else
			print_host_size_im(hostsorthead);
	}
	fprintf(outf,"\n\n<hr>\n<h2><a NAME=\"Host\">");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf,"Hosts report");
	else
		fprintf(outf,"Machines utilisant ce cache");
	fprintf(outf,"</a></h2>\n\n");

	fprintf(outf, "<p>");

	if (hostfloor < 0) {
	  if (hostfloor == -1)
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the first host, ");
	    else
	    	fprintf(outf, "La premi&egrave;re machine, ");
	  else
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the %d first hosts, ", -hostfloor);
	    else
	    	fprintf(outf, "Les %d premi&egrave;res machines, ", -hostfloor);
	}
	else {
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "Printing all hosts, ");
	  else
	  	fprintf(outf, "Toutes les machines, ");
	  if (hostsortby == BYBYTES) {
	    if (hostfloor > 0)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, "with at least %d.%02d%% of the traffic, ",
		     hostfloor / 100, hostfloor % 100);
	      else
	      	fprintf(outf, "avec au moins %d.%02d%% du trafic total, ",
		     hostfloor / 100, hostfloor % 100);
	  }
	  else   /* hostsortby REQUESTS */
	    if (hostfloor > 1)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, "with at least %d requests, ", hostfloor);
	      else
	      	fprintf(outf, "avec au moins %d requ&ecirc;tes, ", hostfloor);
	}
	if (hostsortby == BYREQUESTS)
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "sorted by number of requests.\n\n");
	  else
	  	fprintf(outf, "class&eacute;es par le nombre de requ&ecirc;tes.\n\n");
	else 
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "sorted by amount of traffic.\n\n");
	  else
	  	fprintf(outf, "class&eacute;es par le nombre d'octets.\n\n");
	  	
	fprintf(outf, "\n<p><div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n");
	if(Gq) 
		fprintf(outf, "<tr><th><th>");
	else
		fprintf(outf, "<tr><th>");
		
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Hosts");
	else
		fprintf(outf, "Machines");
	
	
	for (cols = hostcols; *cols != '\0'; cols++) {
	  switch(*cols) {
	  case 'R':
	    fprintf(outf, "<th>#reqs TCP<th>#reqs UDP");
	    break;
	  case 'r':
	    fprintf(outf, "<th>%%reqs ");
	    break;
	  case 'B':
	    fprintf(outf, "<th>#bytes TCP<th>#bytes UDP");
	    break;
	  case 'b':
	    fprintf(outf, "<th>%%bytes ");
	    break;
	  }
	}
	fprintf(outf, "<th>#reqs_hit ");
	fprintf(outf, "<th>%%reqs_hit ");
	fprintf(outf, "<th>#bytes_hit ");
	fprintf(outf, "<th>%%bytes_hit ");

	fprintf(outf, "\n");
	if (hostfloor == 0)
                nbstep = no_hosts;
        else if (hostfloor < 0)
                nbstep = -hostfloor;
        else
                nbstep = no_hostsort;

	if(Gq)
		fprintf(outf, "<tr><td rowspan=\"%d\" valign=\"middle\"> <img src=\"images/host%s.gif\">", nbstep, firstday);
	else
		fprintf(outf, "<tr>");

	if (hostfloor < 0)
	  j = hostfloor;
	else j = 1;
	i=0;
	for(hostp = hostsorthead; hostp -> name != NULL && (j++) != 0;
	    hostp = hostp -> next) {

	  if(!hostp -> is_a_neighbour) {
		  if( i > 0 ) fprintf(outf, "\n<tr>");
		  i++;

	
		  if(!hostp -> is_an_alias) {
		    addr = inet_addr(hostp -> name);
		    if (addr != INET_ADDR_ERR) {
			 addrp = (const char *) &addr;
	  		 tempp = gethostbyaddr(addrp, sizeof(struct in_addr), AF_INET);
			 if (tempp != NULL) {
				fprintf(outf, "<td>%s\n", tempp -> h_name);
			 }
			 else {
				fprintf(outf, "<td>%s\n", hostp -> name);

			 }
		    }
		    else {
			fprintf(outf, "<td>%s\n", hostp -> name);
		    }
		  }
		  else {
			fprintf(outf, "<td>%s\n", hostp -> name);
		  }

		  for (cols = hostcols; *cols != '\0'; cols++) {
		    switch(*cols) {
		    case 'R':
		      fprintf(outf, "<td align=\"right\"> ");
		      int3printf(outf, hostp -> reqs_tcp);
		      fprintf(outf, "<td align=\"right\"> ");
		      int3printf(outf, hostp -> reqs_udp);
		      break;
		    case 'r':
		      if(total_reqs>0) {
		        pc = (hostp -> reqs + 0.0) / ((total_reqs + 0.0) / 10000);
		        pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
		        pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
		        fprintf(outf, "<td align=\"right\">");
		        if (pc1 == 100)
		        	fprintf(outf, "  100%% ");
		        else if (pc1 > 0 || pc2 > 0)
		        	fprintf(outf, "%2d.%02d%% ", pc1, pc2);
		      }
		      else
			fprintf(outf, "<td align=\"right\">");
		      break;
		    case 'B':
			fprintf(outf, "<td align=\"right\"> ");
	        	double3printf(outf, hostp -> bytes_tcp);
			fprintf(outf, "<td align=\"right\"> ");
	        	double3printf(outf, hostp -> bytes_udp);
		      break;
		    case 'b':
			if(total_bytes>0) {
			  pc = hostp -> bytes / (total_bytes / 10000);
			  pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
			  pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */
			  fprintf(outf, "<td align=\"right\">");
			  if (pc1 == 100)
			      fprintf(outf, " 100%% ");
			  else if (pc1 > 0 || pc2 > 0)
			      fprintf(outf, "%2d.%02d%% ", pc1, pc2);
			}
			else
				fprintf(outf, "<td align=\"right\">");
		      break;
		    }
		  }
                  fprintf(outf, "<td align=\"right\"> ");
		  int3printf(outf, hostp-> reqs_hit);

		  if(hostp -> reqs_tcp>0) {
			  pc = (hostp -> reqs_hit + 0.0) / ((hostp -> reqs_tcp + 0.0) / 10000);
	       		  pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
			  pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */			  
			  if(pc1 >= 85)
		      		fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
			  else if(pc1 >= 70)
		      		fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
			  else if(pc1 >= 55)
		     		fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
			  else if(pc1 >= 40)
		      		fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
			  else if(pc1 >= 25)
		      		fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
			  else
		      		fprintf(outf, "<td align=\"right\">");
			  if (pc1 == 100)
	                	fprintf(outf, "  100%% ");
	        	  else if (pc1 > 0 || pc2 > 0)
	                	fprintf(outf, "%2d.%02d%% ", pc1, pc2);
		  }
			

		  fprintf(outf, "<td align=\"right\"> ");
		  double3printf(outf, hostp-> bytes_hit);
		
		  if(hostp -> bytes_tcp > 0) {
 		    pc = (hostp -> bytes_hit + 0.0) / ((hostp -> bytes_tcp + 0.0) / 10000); 
                    pc1 = ((int)(pc + 0.5)) / 100;     
                    pc2 = ((int)(pc + 0.5)) % 100;    
		    if(pc1 >= 85)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
                    else if(pc1 >= 70)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
                    else if(pc1 >= 55)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
                    else if(pc1 >= 40)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
                    else if(pc1 >= 25)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
                    else
                        fprintf(outf, "<td align=\"right\">");
                    if (pc1 == 100)
                        fprintf(outf, "  100%% ");
                    else if (pc1 > 0 || pc2 > 0)
                        fprintf(outf, "%2d.%02d%% ", pc1, pc2);
		  }
		  else {
			fprintf(outf, "<td align=\"right\">");
		  }

          }
	}
	fprintf(outf, "\n</table>\n</div>\n<p>\n");
exit;
	
	if(neighbours) {
		fprintf(outf, "<hr>\n<p>\n");
      		if(strcmp(lang, "EN") == 0)
	  		fprintf(outf,"Printing all the neighbours");
	  	else
	  		fprintf(outf,"Tous les voisins");
	  	fprintf(outf,"\n\n");

	  	fprintf(outf, "\n<p>\n");
	  
	  	fprintf(outf, "\n<p><div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n");
	
		fprintf(outf, "<tr><th>");
		if(strcmp(lang, "EN") == 0)
			fprintf(outf, "Hosts");
		else
			fprintf(outf, "Machines");
	
	
		for (cols = hostcols; *cols != '\0'; cols++) {
	  	switch(*cols) {
	  		case 'R':
	    			fprintf(outf, "<th>#reqs ");
	    			break;
	  		case 'r':
	    			fprintf(outf, "<th>%%reqs ");
	    			break;
	  		case 'B':
	    			fprintf(outf, "<th>#bytes ");
	    			break;
	  		case 'b':
	    			fprintf(outf, "<th>%%bytes ");
	    			break;
	  	}
		}
		fprintf(outf, "<th>#reqs_hit ");
       	 	fprintf(outf, "<th>%%reqs_hit ");
		fprintf(outf, "<th>#bytes_hit ");
        	fprintf(outf, "<th>%%bytes_hit ");
        	fprintf(outf, "<th>#reqs in");
        	fprintf(outf, "<th>#bytes in");

		fprintf(outf, "\n");
	

		if (hostfloor < 0)
	  		j = hostfloor;
		else j = 1;
		i=0;
		for(hostp = hostsorthead; hostp -> name != NULL && (j++) != 0;
	    		hostp = hostp -> next) {

/* on verifie que hostp -> reqs soit > 0 */

	  	  if(hostp -> is_a_neighbour && hostp -> reqs > 0) {
		  fprintf(outf, "\n<tr>");
		  addr = inet_addr(hostp -> name);
		  if (addr != INET_ADDR_ERR) {
			 addrp = (const char *) &addr;
	  		 tempp = gethostbyaddr(addrp, sizeof(struct in_addr), AF_INET);
			 if (tempp != NULL) {
				fprintf(outf, "<td>%s\n", tempp -> h_name);
			 }
			 else {
				fprintf(outf, "<td>%s\n", hostp -> name);
			 }
		  }
		  else {
			fprintf(outf, "<td>%s\n", hostp -> name);
		  }


		for (cols = hostcols; *cols != '\0'; cols++) {
		    switch(*cols) {
		    case 'R':
		      fprintf(outf, "<td align=\"right\"> ");
		      int3printf(outf, hostp -> reqs);
		      break;
		    case 'r':
		      pc = (hostp -> reqs + 0.0) / ((total_reqs + 0.0) / 10000);
		      pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
		      pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
		      fprintf(outf, "<td align=\"right\">");
		      if (pc1 == 100)
			fprintf(outf, "  100%% ");
		      else if (pc1 > 0 || pc2 > 0)
			fprintf(outf, "%2d.%02d%% ", pc1, pc2);
		      break;
		    case 'B':
			fprintf(outf, "<td align=\"right\"> ");
	        	double3printf(outf, hostp -> bytes);
		      break;
		    case 'b':
			pc = hostp -> bytes / (total_bytes / 10000);
			pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
			pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */
			fprintf(outf, "<td align=\"right\">");
			if (pc1 == 100)
			  fprintf(outf, " 100%% ");
			else if (pc1 > 0 || pc2 > 0)
			  fprintf(outf, "%2d.%02d%% ", pc1, pc2);
		      break;
		    }
		  }
                  fprintf(outf, "<td align=\"right\"> ");
		  int3printf(outf, hostp-> reqs_hit);

		  if(hostp -> reqs > 0) {
		  	pc = (hostp -> reqs_hit + 0.0) / ((hostp -> reqs + 0.0) / 10000);
       		  	pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
		  	pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
		  	if(pc1 >= 85)
                       	 	fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
                  	else if(pc1 >= 70)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
                  	else if(pc1 >= 55)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
                  	else if(pc1 >= 40)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
                  	else if(pc1 >= 25)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
		  	else
	      			fprintf(outf, "<td align=\"right\">");
		  	if (pc1 == 100)
                		fprintf(outf, "  100%% ");
        	  	else if (pc1 > 0 || pc2 > 0)
                		fprintf(outf, "%2d.%02d%% ", pc1, pc2);
		  }
		  else {
			fprintf(outf, "<td>");
		  }
                	
		  fprintf(outf, "<td align=\"right\"> ");
		  double3printf(outf, hostp -> bytes_hit);

		  if(hostp -> bytes > 0) {
		  	pc = (hostp -> bytes_hit + 0.0) / ((hostp -> bytes + 0.0) / 10000);
                  	pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
                  	pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
		  	if(pc1 >= 85)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
                  	else if(pc1 >= 70)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
                  	else if(pc1 >= 55)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
                  	else if(pc1 >= 40)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
                  	else if(pc1 >= 25)
                        	fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
                  	else
                        	fprintf(outf, "<td align=\"right\">");
                  	if (pc1 == 100)
                        	fprintf(outf, "  100%% ");
                  	else if (pc1 > 0 || pc2 > 0)
                        	fprintf(outf, "%2d.%02d%% ", pc1, pc2);
		  }
		  else {
                        fprintf(outf, "<td>");
                  }

		  fprintf(outf, "<td align=\"right\"> ");
		  int3printf(outf, hostp -> r_reqs);
		  
		  fprintf(outf, "<td align=\"right\"> ");
		  double3printf(outf, hostp -> r_bytes);
		  
          	}
	  }
      
	  fprintf(outf, "\n</table>\n</div>\n<p>\n");
	}
	  
	  Goto(outf);
	
}

void print_requests(FILE *outf, struct request *requestsorthead)
{
 	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
	extern int total_reqs;
	extern int tcp_reqs, udp_reqs, err_reqs;
	extern double tcp_size, udp_size, err_size;
	extern double total_bytes;
	extern char lang[];  
	extern int num_type_req_tcp, num_type_req_udp, num_type_req_err;
	
	double pc;
	int pc1, pc2;   /* the %age of bytes or reqs for a particular entry */
	int j;
	struct request *requestp;
	char req_type[4];
	int finished;

	
 	fprintf(stderr, "Requests report\n");

	fprintf(outf, "\n\n<hr>\n<h2><a NAME=\"Requests\">");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Requests report");
	else
		fprintf(outf, "Types de requ&ecirc;tes");
	fprintf(outf, "</a></h2>\n\n");
	
        fprintf(outf, "\n<p>\n<div align=\"center\">\n<table cellpadding=\"7\" border=\"1\">\n");
    

	fprintf(outf, "<tr><th colspan=\"2\">");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Requests type");
	else
		fprintf(outf, "Type de Requ&ecirc;tes");
		
	fprintf(outf, "<th>#reqs: <th> %%reqs: <th>#bytes: <th>%%bytes: ");
	

	j = 0;
	finished=0;

	while(j < 3) {
	if(j==0) {
		sprintf(req_type, "UDP");
		if(strcmp(lang, "EN") == 0)
			fprintf(outf, "\n<tr><td valign=\"top\" align=\"left\" rowspan=%d> UDP Requests<td>", num_type_req_udp+1);
		else
			fprintf(outf, "\n<tr><td valign=\"top\" align=\"left\" rowspan=%d> Requ&ecirc;tes UDP<td>", num_type_req_udp+1);
		fprintf(outf, "<td align=\"right\">");
                int3printf(outf, udp_reqs);
                fprintf(outf, "<td align=\"right\">");
                if(total_reqs>0) {
                        pc = (udp_reqs + 0.0) / ((total_reqs + 0.0)/ 10000);
			pc1 = ((int)(pc + 0.5)) / 100;
                        pc2 = ((int)(pc + 0.5)) % 100;
                        fprintf(outf, "%2d.%2d%%", pc1, pc2);
                }
                fprintf(outf, "<td align=\"right\">");
                double3printf(outf, udp_size);
                fprintf(outf, "<td align=\"right\">");
                if(total_bytes>0.0){
                        pc = (udp_size) / (total_bytes /10000);
                        pc1 = ((int)(pc + 0.5)) / 100;
                        pc2 = ((int)(pc + 0.5)) % 100;
                        fprintf(outf, "%2d.%02d%%", pc1, pc2);
                }
	}
	if(j==1) {
		sprintf(req_type, "TCP");
		if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "\n<tr><td valign=\"top\" align=\"left\" rowspan=%d> TCP Requests<td>", num_type_req_tcp+1);
		else
                	fprintf(outf, "\n<tr><td valign=\"top\" align=\"left\" rowspan=%d> Requ&ecirc;tes TCP<td>", num_type_req_tcp+1);
		fprintf(outf, "<td align=\"right\">");
                int3printf(outf, tcp_reqs);
                fprintf(outf, "<td align=\"right\">");
                if(total_reqs>0) {
                        pc = (tcp_reqs + 0.0) / ((total_reqs + 0.0)/ 10000);
                        pc1 = ((int)(pc + 0.5)) / 100;
                        pc2 = ((int)(pc + 0.5)) % 100;
                        fprintf(outf, "%2d.%02d%%", pc1, pc2);
                }
                fprintf(outf, "<td align=\"right\">");
                double3printf(outf, tcp_size);
                fprintf(outf, "<td align=\"right\">");
                if(total_bytes>0.0){
                        pc = (tcp_size) / (total_bytes /10000);
                        pc1 = ((int)(pc + 0.5)) / 100;
                        pc2 = ((int)(pc + 0.5)) % 100;
                        fprintf(outf, "%2d.%02d%%", pc1, pc2);
                }
	}
	if(j==2) {
		sprintf(req_type, "ERR");
		if(strcmp(lang, "EN") == 0)
			fprintf(outf, "\n<tr><td valign=\"top\" align=\"left\" rowspan=%d> Errors<td>", num_type_req_err+1);
		else
			fprintf(outf, "\n<tr><td valign=\"top\" align=\"left\" rowspan=%d> Requ&ecirc;tes en erreur<td>", num_type_req_err+1);
                fprintf(outf, "<td align=\"right\">");
                int3printf(outf, err_reqs);
                fprintf(outf, "<td align=\"right\">");
                if(total_reqs>0) {
                        pc = (err_reqs + 0.0) / ((total_reqs + 0.0)/ 10000);
                        pc1 = ((int)(pc + 0.5)) / 100;
                        pc2 = ((int)(pc + 0.5)) % 100;
                        fprintf(outf, "%2d.%02d%%", pc1, pc2);
                }
                fprintf(outf, "<td align=\"right\">");
                double3printf(outf, err_size);
                fprintf(outf, "<td align=\"right\">");
                if(total_bytes>0.0){
                        pc = (err_size) / (total_bytes /10000);
                        pc1 = ((int)(pc + 0.5)) / 100;
                        pc2 = ((int)(pc + 0.5)) % 100;
                        fprintf(outf, "%2d.%02d%%", pc1, pc2);
                }
	}
	for(requestp = requestsorthead; requestp -> name != NULL ;
	    requestp = requestp -> next) {

	  if(strncmp(requestp -> name, req_type, 3) == 0) {
		  fprintf(outf, "\n<tr><td>%s", requestp -> name);
		  fprintf(outf, "<td align=\"right\"> ");
		  int3printf(outf, requestp -> reqs);
		  if(total_reqs>0) {
			  pc = (requestp -> reqs + 0.0) / ((total_reqs + 0.0) / 10000);
			  pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
			  pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
			  if (pc1 == 100)
				fprintf(outf, "<td align=\"right\">  100%% ");
			  else if (pc1 > 0 || pc2 > 0)
				fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
			  else
				fprintf(outf, "<td align=\"right\">       ");
		  }
		  fprintf(outf, "<td align=\"right\"> ");
		  double3printf(outf, requestp -> bytes);
		  if(total_bytes>0) {
			  pc = requestp -> bytes / (total_bytes / 10000);
			  pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
			  pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */
			  if (pc1 == 100)
			        fprintf(outf, "<td align=\"right\">  100%% ");
			  else if (pc1 > 0 || pc2 > 0)
			        fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
			  else
			        fprintf(outf, "<td align=\"right\">       ");
		  }
/*
		  if(requestp -> reqs > 0) {
			  pc = requestp -> time / (requestp -> reqs + 0.0);
			  pc1 = ((int)(pc + 0.5));
			  if(pc1>0)
			  	fprintf(outf, "<td align=\"right\">%2d", pc1);
			  else
				fprintf(outf, "<td align=\"right\">");
		  }
		  else {
			fprintf(outf, "<td align=\"right\">");
		  }
		  if(requestp -> time > 0) {
			  pc = 7.8125*requestp -> bytes/requestp -> time;
			  if(pc>0)
			  	fprintf(outf, "<td align=\"right\">%.2f", pc);
			  else
                                fprintf(outf, "<td align=\"right\">");
		  }
		  else {
			fprintf(outf, "<td align=\"right\">");
		  }
*/
	  }
	}
	j++;
	}
      
	  fprintf(outf, "\n</table></div>\n");
	  Goto(outf);

}

void print_proto(FILE *outf, struct proto *protosorthead)
{
 	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
	extern int total_reqs;
	extern double total_bytes;
	extern char lang[];  
 	extern int protosortby;
  	extern int protofloor;
	
	double pc;
	int pc1, pc2;   /* the %age of bytes or reqs for a particular entry */
	int j;
	char *cols;
	struct proto *protop;
	extern char protocols[];

	
 	fprintf(stderr, "Protocol report\n");

	fprintf(outf, "\n\n<hr>\n<h2><a NAME=\"Protocol\">");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Protocol report");
	else
		fprintf(outf, "Protocoles utilis&eacute;s");
	fprintf(outf, "</a></h2>\n\n");
	
	  fprintf(outf, "<p>");
	if (protofloor < 0) {
	  if (protofloor == -1)
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the first protocol, ");
	    else
	    	fprintf(outf, "Le premier protocole, ");
	  else
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the %d first protocols, ", -protofloor);
	    else
	    	fprintf(outf, "Les  %d premiers protocoles, ", -protofloor);
	}
	else {
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "Printing all protocols, ");
	  else
	  	fprintf(outf, "Tous les protocoles, ");
	  if (protosortby == BYBYTES) {
	    if (protofloor > 0)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, "with at least %d.%02d%% of the traffic, ",
		      protofloor / 100, protofloor % 100);
	      else
	      	fprintf(outf, "avec au moins %d.%02d%% du trafic total, ",
		      protofloor / 100, protofloor % 100);
	  }
	  else   /* protosortby REQUESTS */
	    if (protofloor > 1)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, "with at least %d requests, ", protofloor);
	      else
	      	fprintf(outf, "avec au moins %d requ&ecirc;tes, ", protofloor);
	}
	if (protosortby == BYREQUESTS)
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "sorted by number of requests.\n\n");
	  else
	  	fprintf(outf, "class&eacute;s par le nombre de requ&ecirc;tes.\n\n");
	else
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "sorted by amount of traffic.\n\n");
	  else
	  	fprintf(outf, "class&eacute;s par le nombre d'octets.\n\n");

        fprintf(outf, "\n<p>\n<div align=\"center\">\n<table cellpadding=\"7\" border=\"1\">\n");
    

	fprintf(outf, "<tr><th>");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Protocols");
	else
		fprintf(outf, "Protocoles");
		
	for (cols = protocols; *cols != '\0'; cols++) {
	  switch(*cols) {
	  case 'R':
	    fprintf(outf, "<th>#reqs: ");
	    break;
	  case 'r':
	    fprintf(outf, "<th> %%reqs: ");
	    break;
	  case 'B':
	    fprintf(outf, "<th>#bytes: ");
	    break;
	  case 'b':
	    fprintf(outf, "<th>%%bytes: ");
	    break;
	  }
	}
	

	if (protofloor < 0)
	  j = protofloor;
	else j = 1;

	for(protop = protosorthead; protop -> name != NULL && (j++) != 0;
	    protop = protop -> next) {

	  fprintf(outf, "\n<tr><td>%s", protop -> name);
	  for (cols = protocols; *cols != '\0'; cols++) {
	    switch(*cols) {
	    case 'R':
	      fprintf(outf, "<td align=\"right\"> ");
	      int3printf(outf, protop -> reqs);
	      break;
	    case 'r':
	      pc = (protop -> reqs + 0.0) / ((total_reqs + 0.0) / 10000);
	      pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
	      pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
	      if (pc1 == 100)
		fprintf(outf, "<td align=\"right\">  100%% ");
	      else if (pc1 > 0 || pc2 > 0)
		fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
	      else
		fprintf(outf, "<td align=\"right\">       ");
	      break;
	    case 'B':
	      fprintf(outf, "<td align=\"right\"> ");
	      double3printf(outf, protop -> bytes);
	      break;
	    case 'b':
	      pc = protop -> bytes / (total_bytes / 10000);
	      pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
	      pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */
	      if (pc1 == 100)
	        fprintf(outf, "<td align=\"right\">  100%% ");
	      else if (pc1 > 0 || pc2 > 0)
	        fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
	      else
	        fprintf(outf, "<td align=\"right\">       ");
	      break;
	    }
	  }


	}
      
	  fprintf(outf, "\n</table></div>\n");
	  Goto(outf);

}

void print_remote_sites(FILE *outf, struct url *urlsorthead)
{
  	extern int no_reqsort;
 	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
  	extern char firstday[];
  	extern flag Gq;
	extern int total_reqs;
	extern double total_bytes;
	extern char lang[];  
	extern int no_urls;
 	extern int sitessortby;
  	extern int sitesfloor;
	extern char baseurl[];
	extern char sitescols[];


	double pc;
	int pc1, pc2;   /* the %age of bytes or reqs for a particular entry */
	int i, j, nbstep;
	char *cols;
	struct url *urlp;


	fprintf(stderr, "Remote sites report\n");

	if (strcmp(baseurl, "none") == 0)
	  strcpy(baseurl, "");

	  if(Gq) {
                if(sitessortby == BYREQUESTS)
                        print_remote_host_im(urlsorthead);
                else 
		if(sitessortby == BYBYTES)
                        print_remote_host_size_im(urlsorthead);
		else
			print_remote_host_im(urlsorthead);
          }

	fprintf(outf,"\n\n<hr>\n<h2><a NAME=\"Remote sites\">");
	if(strcmp(lang, "EN") == 0)
		fprintf(outf,"Remote sites report");
	else
		fprintf(outf,"Sites distants acc&eacute;d&eacute;s");
		
	fprintf(outf,"</a></h2>\n\n");
	

	  fprintf(outf, "<p>\n");
	if (sitesfloor < 0) {
	  if (sitesfloor == -1)
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the first site, ");
	    else
	    	fprintf(outf, "Le premier site, ");
	  else
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "Printing the %d first sites, ", -sitesfloor);
	    else
	    	fprintf(outf, "Les %d premiers sites, ", -sitesfloor);
	}
	else {
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "Printing all sites, ");
	  else
	  	fprintf(outf, "Tous les sites, ");
	  if (sitessortby == BYBYTES) {
	    if (sitesfloor > 0)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, " with at least %d.%02d%% of the traffic, ",
		      sitesfloor / 100, sitesfloor % 100);
	      else
	      	fprintf(outf, " avec au moins %d.%02d%% du trafic total, ",
		      sitesfloor / 100, sitesfloor % 100);
	  }
	  else   /* sitessortby REQUESTS  */
	    if (sitesfloor > 1)
	      if(strcmp(lang, "EN") == 0)
	      	fprintf(outf, " with at least %d requests, ", sitesfloor);
	      else
	      	fprintf(outf, " avec au moins %d requ&ecirc;tes, ", sitesfloor);
	}
	  if (sitessortby == BYREQUESTS)
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "sorted by number of requests.\n\n");
	    else
	    	fprintf(outf, "class&eacute;s par le nombre de requ&ecirc;tes.\n\n");
	  else
	    if(strcmp(lang, "EN") == 0)
	    	fprintf(outf, "sorted by amount of traffic.\n\n");
	    else
	    	fprintf(outf, "class&eacute;s par le nombre d'octets.\n\n");
	    	
	  fprintf(outf, "\n<p><div align=\"center\"><table cellpadding=\"5\" border=\"1\">\n");
    

	if(Gq)
		fprintf(outf, "<tr><th><th>");
	else
		fprintf(outf, "<tr><th>");
		
	if(strcmp(lang, "EN") == 0)
		fprintf(outf, "Sites");
	else
		fprintf(outf, "Serveurs");
	
	for (cols = sitescols; *cols != '\0'; cols++) {
	  switch(*cols) {
	  case 'R':
	    fprintf(outf, "<th>#reqs ");
	    break;
	  case 'r':
	    fprintf(outf, "<th> %%reqs ");
	    break;
	  case 'B':
	    fprintf(outf, "<th>#bytes ");
	    break;
	  case 'b':
	    fprintf(outf, "<th>%%bytes ");
	    break;
	  }
	}
	fprintf(outf, "<th>#reqs_hit ");
        fprintf(outf, "<th>%%reqs_hit ");
        fprintf(outf, "<th>#bytes_hit ");
        fprintf(outf, "<th>%%bytes_hit ");

	if (sitesfloor == 0)
                nbstep = no_urls;
        else if (sitesfloor < 0)
                nbstep = -sitesfloor;
        else
                nbstep = no_reqsort;

	if(Gq)
		fprintf(outf, "<tr><td rowspan=\"%d\" valign=\"middle\"> <img src=\"images/remote_host%s.gif\">", nbstep, firstday);
	else
		fprintf(outf, "<tr>");

	if (sitesfloor < 0)
	  j = sitesfloor;
	else j = 1;

	i = 0;
	for(urlp = urlsorthead; urlp -> name != NULL && (j++) != 0;
	    urlp = urlp -> next) {


	  if( Gq ) {
		if( i > 0 ) fprintf(outf, "\n<tr>");
	  }
	  else
		fprintf(outf, "\n<tr>");

          fprintf(outf, "<td>%s", urlp -> name);
	  i++;

	  for (cols = sitescols; *cols != '\0'; cols++) {
	    switch(*cols) {
	    case 'R':
	      fprintf(outf, "<td align=\"right\"> ");
	      int3printf(outf, urlp -> reqs);
	      break;
	    case 'r':
	      pc = (urlp -> reqs + 0.0) / ((total_reqs + 0.0) / 10000);
	      pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
	      pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
	      if (pc1 == 100)
		fprintf(outf, "<td align=\"right\">  100%% ");
	      else if (pc1 > 0 || pc2 > 0)
		fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
	      else
		fprintf(outf, "<td align=\"right\">       ");
	      break;
	    case 'B':
	      fprintf(outf, "<td align=\"right\"> ");
	      double3printf(outf, urlp -> bytes);
	      break;
	    case 'b':
	      pc = urlp -> bytes / (total_bytes / 10000);
	      pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
	      pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */
	      if (pc1 == 100)
	        fprintf(outf, "<td align=\"right\">  100%% ");
	      else if (pc1 > 0 || pc2 > 0)
	        fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
	      else
	        fprintf(outf, "<td align=\"right\">       ");
	      break;
	    }
	  }
	  fprintf(outf, "<td align=\"right\"> ");
          int3printf(outf, urlp-> reqs_hit);
          if(urlp -> reqs>0) {
                  pc = (urlp -> reqs_hit + 0.0) / ((urlp -> reqs + 0.0) / 10000);
                  pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
                  pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
                  if(pc1 >= 85)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
                  else if(pc1 >= 70)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
                  else if(pc1 >= 55)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
                  else if(pc1 >= 40)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
                  else if(pc1 >= 25)
                        fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
                  else
                        fprintf(outf, "<td align=\"right\">");
                  if (pc1 == 100)
                        fprintf(outf, "  100%% ");
                  else if (pc1 > 0 || pc2 > 0)
                        fprintf(outf, "%2d.%02d%% ", pc1, pc2);
          }


          fprintf(outf, "<td align=\"right\"> ");
          double3printf(outf, urlp-> bytes_hit);

          if(urlp -> bytes > 0) {
            pc = (urlp -> bytes_hit + 0.0) / ((urlp -> bytes + 0.0) / 10000);
            pc1 = ((int)(pc + 0.5)) / 100;
            pc2 = ((int)(pc + 0.5)) % 100;
            if(pc1 >= 85)
                fprintf(outf, "<td align=\"right\" bgcolor=\"#4444ff\">");
            else if(pc1 >= 70)
                fprintf(outf, "<td align=\"right\" bgcolor=\"#6666ff\">");
            else if(pc1 >= 55)
                fprintf(outf, "<td align=\"right\" bgcolor=\"#8888ff\">");
            else if(pc1 >= 40)
                fprintf(outf, "<td align=\"right\" bgcolor=\"#aaaaff\">");
            else if(pc1 >= 25)
                fprintf(outf, "<td align=\"right\" bgcolor=\"#ddddff\">");
            else
                fprintf(outf, "<td align=\"right\">");
            if (pc1 == 100)
                fprintf(outf, "  100%% ");
            else if (pc1 > 0 || pc2 > 0)
                fprintf(outf, "%2d.%02d%% ", pc1, pc2);
          }
          else {
                fprintf(outf, "<td align=\"right\">");
          }

	}
      
	  fprintf(outf, "\n</table>\n</div>");
	  Goto(outf);
	
}

void print_mime(FILE *outf, struct mime_types *mimesorthead)
{
  	extern int no_mimesort;
 	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
  	extern char firstday[];
	extern int total_reqs;
	extern double total_bytes;
	extern char lang[];  
	extern int no_mimes;
 	extern int mimesortby;
  	extern int mimefloor;
  	extern char mimecols[];
	extern flag Gq;


	double pc;
	int pc1, pc2;   /* the %age of bytes or reqs for a particular entry */
	int i, j, nbstep;
	char *cols;
	struct mime_types *mimep;
	
	
	  fprintf(stderr, "Mime type Report\n");
	  if(Gq) {
		if(mimesortby == BYREQUESTS)
                        print_mime_im(mimesorthead);
                else
                        print_mime_size_im(mimesorthead);
	  }
          fprintf(outf, "\n\n<hr>\n<h2><a NAME=\"Mime\">");
          if(strcmp(lang, "EN") == 0)
          	fprintf(outf, "Mime type report");
          else
          	fprintf(outf, "Types mime");
          	
          fprintf(outf, "</a></h2>\n\n");
          fprintf(outf, "<p>");
          if (mimefloor < 0) {
          if (mimefloor == -1)
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "Printing the first type, ");
            else
            	fprintf(outf, "Le premier type, ");
          else
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "Printing the %d first types, ", -mimefloor);
            else
            	fprintf(outf, "Les %d premiers types, ", -mimefloor);
          }
          else {
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "Printing all types, ");
            else
            	fprintf(outf, "Tous les types, ");
            if (mimesortby == BYBYTES) {
              if (mimefloor > 0)
                if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "with at least %d.%02d%% of the traffic, ",
                       	mimefloor / 100, mimefloor % 100);
                else
                	fprintf(outf, "avec au moins %d.%02d%% du trafic total, ",
                       	mimefloor / 100, mimefloor % 100);
            }
            else   /* mimesortby REQUESTS  */
              if (mimefloor > 1)
                if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "with at least %d requests, ", mimefloor);
                else
                	fprintf(outf, "avec au moins %d requ&ecirc;tes, ", mimefloor);
          }
          if (mimesortby == BYREQUESTS)
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "sorted by number of requests.\n\n");
            else
            	fprintf(outf, "class&eacute;s par le nombre de requ&ecirc;tes.\n\n");
          else
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "sorted by amount of traffic.\n\n");
            else
            	fprintf(outf, "class&eacute;s par le nombre d'octets.\n\n");
          fprintf(outf, "\n<p><div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n");
	  if(Gq)
                fprintf(outf, "<tr><th><th>");
          else
          	fprintf(outf, "<tr><th>");
          	
          if(strcmp(lang, "EN") == 0)
          	fprintf(outf, "Mime types\n");
          else
                fprintf(outf, "Types mime\n");


          for (cols = mimecols; *cols != '\0'; cols++) {
            switch(*cols) {
            case 'R':
              fprintf(outf, "<th>#reqs ");
              break;
            case 'r':
              fprintf(outf, "<th>%%reqs ");
              break;
            case 'B':
              fprintf(outf, "<th>#bytes ");
              break;
            case 'b':
              fprintf(outf, "<th>%%bytes ");
              break;
            }
          }

          fprintf(outf, "\n");

	  if (mimefloor == 0)
                nbstep = no_mimes;
          else if (mimefloor < 0)
                nbstep = -mimefloor;
          else
                nbstep = no_mimesort;

          if (mimefloor < 0)
            j = mimefloor;
          else j = 1;

	  if(Gq)
                fprintf(outf, "<tr><td rowspan=\"%d\" valign=\"middle\"> <img src=\"images/mime%s.gif\">", nbstep, firstday);
	  else
                fprintf(outf, "<tr>");

	  i = 0;
          for(mimep = mimesorthead; mimep -> name != NULL && (j++) != 0;
              mimep = mimep -> next) {

	  if( i > 0 ) fprintf(outf, "\n<tr>");
	  i++;

          fprintf(outf, "<td>%s\n", mimep -> name);

          for (cols = mimecols; *cols != '\0'; cols++) {
            switch(*cols) {
            case 'R':
              fprintf(outf, "<td align=\"right\"> ");
	      int3printf(outf,  mimep -> reqs);

              break;
            case 'r':
              pc = (mimep -> reqs + 0.0) / ((total_reqs + 0.0) / 10000);
              pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
              pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
              if (pc1 == 100)
                fprintf(outf, "<td align=\"right\">  100%% ");
              else if (pc1 > 0 || pc2 > 0)
                fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
              else
                fprintf(outf, "<td align=\"right\">");
              break;
            case 'B':
              fprintf(outf, "<td align=\"right\"> ");
	      double3printf(outf, mimep-> bytes);
              break;
            case 'b':
                pc = mimep -> bytes / (total_bytes / 10000);
                pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
                pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */

               if (pc1 == 100)
                  fprintf(outf, " <td align=\"right\"> 100%% ");
                else if (pc1 > 0 || pc2 > 0)
                  fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
                else
                  fprintf(outf, "<td align=\"right\">");
              break;
            }
          }
        }

          fprintf(outf, "\n</table>\n</div>\n<p>\n");
          Goto(outf);

}

void print_type(FILE *outf, struct file_types *typesorthead)
{

	
 	extern char *reversehostname();   /* in alias.c */
  	extern int minsbetween();         /* in utilities.c */
  	extern void int3printf();         /* in utilities.c */
  	extern void double3printf();      /* in utilities.c */
	extern int total_reqs;
	extern double total_bytes;
	extern char lang[];  
 	extern int typesortby;
  	extern int typefloor;
  	extern char typecols[];


	double pc;
	int pc1, pc2;   /* the %age of bytes or reqs for a particular entry */
	int j;
	char *cols;
	struct file_types *typep;


	  fprintf(outf, "File type Report\n");
	  
	  fprintf(outf, "\n\n<hr>\n<h2><a NAME=\"Type\">");
	  
	  if(strcmp(lang, "EN") == 0)
	  	fprintf(outf, "File types report");
	  else
	  	fprintf(outf, "Types de fichiers");
	  	
	  fprintf(outf, "</a></h2>\n\n");
	  fprintf(outf, "<p>");
	  if (typefloor < 0) {
            if (typefloor == -1)
              if(strcmp(lang, "EN") == 0)
              	fprintf(outf, "Printing the first type, ");
              else
              	fprintf(outf, "Le premier type, ");
            else
              if(strcmp(lang, "EN") == 0)
              	fprintf(outf, "Printing the %d firts types, ", -typefloor);
              else
              	fprintf(outf, "Les %d premiers types, ", -typefloor);
          }
          else {
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "Printing all types, ");
            else
            	fprintf(outf, "Tous les types, ");
            if (typesortby == BYBYTES) {
              if (typefloor > 0)
                if(strcmp(lang, "EN") == 0)
                	fprintf(outf, "with at least %d.%02d%% of the traffic, ",
                       	typefloor / 100, typefloor % 100);
                else
                	fprintf(outf, "avec au moins %d.%02d%% du trafic total, ",
                       	typefloor / 100, typefloor % 100);
            }
            else   /* typesortby REQUESTS */
            if (typefloor > 1)
              if(strcmp(lang, "EN") == 0)
              	fprintf(outf, "with at least %d requests, ", typefloor);
              else
              	fprintf(outf, "avec au moins %d requ&ecirc;tes, ", typefloor);
          }
          if (typesortby == BYREQUESTS)
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "sorted by number of requests.\n\n");
            else
            	fprintf(outf, "class&eacute;s par le nombre de requ&ecirc;tes.\n\n");
          else
            if(strcmp(lang, "EN") == 0)
            	fprintf(outf, "sorted by amount of traffic.\n\n");
            else
            	fprintf(outf, "class&eacute;s par le nombre d'octets.\n\n");
          fprintf(outf, "\n<p><div align=\"center\">\n<table cellpadding=\"5\" border=\"1\">\n");
          fprintf(outf, "<tr><th>type<th>mime type");


          for (cols = typecols; *cols != '\0'; cols++) {
            switch(*cols) {
            case 'R':
              fprintf(outf, "<th>#reqs ");
              break;
            case 'r':
              fprintf(outf, "<th>%%reqs ");
              break;
            case 'B':
              fprintf(outf, "<th>#bytes ");
              break;
            case 'b':
              fprintf(outf, "<th>%%bytes ");
              break;
            }
          }
  
          fprintf(outf, "\n");
  
  
          if (typefloor < 0)
            j = typefloor;
          else j = 1;

          for(typep = typesorthead; typep -> name != NULL && (j++) != 0;
              typep = typep -> next) {

            fprintf(outf, "\n<tr>");


            fprintf(outf, "<td>%s\n", typep -> name);
            fprintf(outf, "<td>%s\n", typep -> real_name);

            for (cols = typecols; *cols != '\0'; cols++) {
              switch(*cols) {
              case 'R':
                fprintf(outf, "<td align=\"right\"> ");
		int3printf(outf, typep -> reqs);
                break;
              case 'r':
                pc = (typep -> reqs + 0.0) / ((total_reqs + 0.0) / 10000);
                pc1 = ((int)(pc + 0.5)) / 100;     /* whole no. of %reqs */
                pc2 = ((int)(pc + 0.5)) % 100;     /* remaining 100ths. */
                if (pc1 == 100)
                  fprintf(outf, "<td align=\"right\">  100%% ");
                else if (pc1 > 0 || pc2 > 0)
                  fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
                else
                  fprintf(outf, "<td align=\"right\">");
                break;
              case 'B':
                fprintf(outf, "<td align=\"right\"> ");
		double3printf(outf, typep-> bytes);
                break;
              case 'b':
                  pc = typep -> bytes / (total_bytes / 10000);
                  pc1 = ((int)(pc + 0.5)) / 100;    /* whole no. of %bytes */
                  pc2 = ((int)(pc + 0.5)) % 100;    /* remaining 100ths. */
  
                 if (pc1 == 100)
                    fprintf(outf, " <td align=\"right\"> 100%% ");
                  else if (pc1 > 0 || pc2 > 0)
                    fprintf(outf, "<td align=\"right\">%2d.%02d%% ", pc1, pc2);
                  else
                    fprintf(outf, "<td align=\"right\">");
                break;
              }
            }
          }

          fprintf(outf, "\n</table>\n</div>\n<p>\n");
          Goto(outf);


}


/* The rest is one long and dull function , but I see no point in splitting
   it up further */

void output(struct url *urlsorthead, struct proto *protosorthead, struct request *requestsorthead,
	    struct host *hostsorthead, struct file_types *typesorthead, struct mime_types *mimesorthead, int firstdom)
{
  extern void write_cumul();

  extern flag dq, hq, mq, Sq, sq, Rq, oq, Pq, tq, Cq;
  extern struct timeval starttime, stoptime;
  extern struct timezone tzp;
  extern char outfile[];
  extern char commandname[];
  extern char reportorder[];
  extern char footerfile[];
  extern char lang[], version[];  
  extern char firstday[];

  FILE *outf;       /* the output file */
  char tempstr[MAXSTRINGLENGTH];
  FILE *tempf;
  char file[MAXSTRINGLENGTH];
  char *ro;

  if (strcmp(outfile, "stdout") == 0) 
    outf = stdout;
  else {
      sprintf(file, "%s/stat%s.html", outfile, firstday);
    if ((outf = fopen(file, "w")) == NULL) {
      fprintf(stderr, "%s: Error: failed to open output file %s for writing.\n",
	    commandname, outfile);
      exit(ERR);  /* shouldn't get here because also tested at the beginning */
    }
  }

  print_general(outf);

  /*** Now for the rest of the reports, in reportorder order ***/

  for (ro = reportorder; *ro != '\0'; ro++) {

    switch(*ro) {

      
    case 'd':      /* Daily summary */

      if (dq) {
		print_daily(outf);	
	}

      break;
      
    case 'h': /* Hourly summary */

      if (hq) {
		print_hourly(outf);
	}
      
      break;

    case 'D':    /* Domain report */

      if (oq) {
		print_domain(outf, firstdom);
	}

      break;

    case 'S':    /* Host report */
   
      if (Sq) {
		print_host(outf, hostsorthead);
	}

      break;
    
    case 'P':   /* Protocol report */
   
      if (Pq) {
		print_proto(outf, protosorthead);
	}

      break;

    case 's':    /* Remote sites report */
      if (sq) {
		print_remote_sites(outf, urlsorthead);
	}

      break;

    case 'm' : /* Mime type Report */
        if (mq) {
		print_mime(outf, mimesorthead);
	}

      break;

    case 't' : /* File type Report */
	if (tq) {
		print_type(outf, typesorthead);
	}

      break;

    case 'R' : /* Requests Report */
	if (Rq) {
                print_requests(outf, requestsorthead);
	}

      break;

    }    /* end switch */
  }      /* end for ro */

  /* Bit at the bottom of the page */


  
  

  /* Finally, insert footer file */

  footerfile[MAXSTRINGLENGTH - 5] = '\0';  /* for safety */

  if (strcmp(footerfile, "none") != 0) {
    if ((tempf = fopen(footerfile, "r")) == NULL) {
      fprintf(stderr,
	      "%s: Warning: Failed to open footer file %s: ignoring it.\n",
	      commandname, footerfile);
    }
    else {  /* can open footer file */
	fprintf(outf, "<hr>");
      fprintf(outf, "\n\n");
      fflush(stdout);

      while(fgets(tempstr, MAXLINELENGTH, tempf) != NULL)
	fprintf(outf, "%s", tempstr);
      fclose(tempf);
      if (tempstr[strlen(tempstr) - 1] != '\n')
	fprintf(outf, "\n");

      fprintf(outf, "\n");
    }
  }
  
  if(strcmp(lang, "EN") == 0)
	fprintf(outf, "\n<p>\n<hr>\n<i>Generated by <a href=\"http://cache.cnrs.fr/prostat/\">prostat v%s</a>. ", version);
  else
	fprintf(outf, "\n<p>\n<hr>\n<i>Produit par <a href=\"http://cache.cnrs.fr/prostat/\">prostat v%s</a>. ", version);
  gettimeofday(&stoptime, &tzp);
  
  stoptime.tv_sec -= starttime.tv_sec;
  stoptime.tv_usec -= starttime.tv_usec;   /* so now measures elapsed time */
  
  if (stoptime.tv_usec < -500000)
    stoptime.tv_sec--;

  if (stoptime.tv_usec >= 500000)
    stoptime.tv_sec++;

  if (stoptime.tv_sec == 0) {
      fprintf(outf, "\nRunning time: Less than 1 second.</i>\n");
  }

  else if (stoptime.tv_sec < 60) {
      fprintf(outf, "\nRunning time: %ld second%s.</i>\n",
	     stoptime.tv_sec, ((stoptime.tv_sec) == 1)?"":"s");
  }
  
  else {
      fprintf(outf,
	      "\nRunning time: %ld minute%s, %ld second%s.</i>\n",
	     stoptime.tv_sec / 60, ((stoptime.tv_sec / 60) == 1)?"":"s",
	     stoptime.tv_sec % 60, ((stoptime.tv_sec % 60) == 1)?"":"s");
  }
  fprintf(outf, "\n</body>\n</html>\n");
  fclose(outf);
  
  if(Cq) write_cumul();  

}

void write_cumul()
{
	extern int tcp_reqs, udp_reqs, req_hit, no_hosts;
	extern double tcp_size, udp_size, req_hit_size;
	extern struct timestruct firsttime, lasttime;
	extern char outfile[];
	extern char commandname[];
	extern char hostname[];
	extern char logourl[], lang[], version[];
	extern flag logoq;
	extern char background[];
	extern char hosturl[];
	extern flag Gq;
   	extern void int3printf();         /* in utilities.c */
   	extern void double3printf();         /* in utilities.c */
	extern int sscan_cum();

	FILE *outf, *outh, *outi1, *outi2;
	char file[MAXSTRINGLENGTH];
	char inputline[MAXLINELENGTH];
	int no_reqs, no_hits, no_udp_reqs, firstdate, firstyear, firstmon, lastmon, mon_max, lastdate, lastyear, date_max, year_max, total_reqs;
	int mon_max_r, date_max_r, year_max_r, mon_max_b, date_max_b, year_max_b;
	double no_bytes, no_bytes_hits;
	double pc, max_hit_r, max_hit_b;
	char firstperiod[12], lastperiod[12];
	char bytestr[16], udp_bytestr[16], bytestr_hits[16];
	gdImagePtr im1, im2;
	int black;
        int white;
	int color1, color2, color3, color4;
	int width, height, margex, margey, nbstep, taillex, tailley, max_reqs, i, j;
	float stepx, x1, x2, y1, y2, xx11, xx12, xx21, xx22, yy11, yy12, yy21, yy22;
	int num_period, num_date;
	char tab_date[100][24];
	char s[30];


	sprintf(file, "%s/proxy.db", outfile);
	if ((outf = fopen(file, "a")) == NULL) {
      		fprintf(stderr, "%s: Error: failed to open output file %s for writing.\n",
            		commandname, outfile);
      		exit(ERR);  /* shouldn't get here because also tested at the beginning */
	}
	fprintf(outf, "x:%d:%d:%d:%.0f:%.0f:%.0f:%d:%02d %02d %4d:%02d %02d %4d\n", tcp_reqs, req_hit, udp_reqs, tcp_size, req_hit_size, udp_size, no_hosts, firsttime.date, firsttime.monthno+1, firsttime.year, lasttime.date, lasttime.monthno+1, lasttime.year);
	fclose(outf);

	num_period = 0;
	if ((outf = fopen(file, "r")) == NULL) {
		fprintf(stderr, "%s: Error: failed to open output file %s for reading.\n",
                        commandname, outfile);
                exit(ERR);
        }
	max_reqs = 0;
	max_hit_r = max_hit_b = 0;
	while(fgets(inputline, MAXLINELENGTH, outf) != NULL) { 
		num_period++; 
		sscan_cum(inputline, &no_reqs, &no_hits, bytestr, bytestr_hits, &no_udp_reqs, udp_bytestr, &firstdate, &firstmon, &firstyear, &lastdate, &lastmon, &lastyear);
		if(max_reqs == 0) {
			sprintf(firstperiod, "%02d/%02d/%4d", firstdate, firstmon, firstyear);
		}
		total_reqs=no_reqs+no_udp_reqs;
		if(total_reqs > max_reqs) {
			max_reqs = total_reqs;
			date_max = firstdate;
			year_max = firstyear;
			mon_max = firstmon;
		}
	}
	sprintf(lastperiod, "%02d/%02d/%4d", firstdate, firstmon, firstyear);
	fclose(outf);
	if(Gq) {
		width = 410;
        	height = 210;
	        margex=25;
        	margey=20;
		if(num_period <= 100 )
	        	nbstep = num_period;
		else
			nbstep = 100;
	        taillex = width -2*margex;
	        tailley = height -2*margey;
        	stepx=(float)(width-2*margex)/nbstep;
	        im1 = gdImageCreate(width, height);
	        black = gdImageColorAllocate(im1, 0, 0, 0);
	        white = gdImageColorAllocate(im1, 255, 255, 255);
	        color1 = gdImageColorAllocate(im1, 204, 204, 204);
	        x1 = y1 = 0;
	        x2 = width - 1;
		y2 = height - 1;
	        gdImageFilledRectangle(im1, (int)x1, (int)y1, (int)x2, (int)y2, color1);
	        gdImageColorTransparent(im1, color1);
                im2 = gdImageCreate(width, height);
                black = gdImageColorAllocate(im2, 0, 0, 0);
                white = gdImageColorAllocate(im2, 255, 255, 255);
                color1 = gdImageColorAllocate(im2, 204, 204, 204);
                gdImageFilledRectangle(im2, (int)x1, (int)y1, (int)x2, (int)y2, color1);
                gdImageColorTransparent(im2, color1);
		x1 = x2 = margex;
		y1 = margey;
		y2 = height - margey;
		gdImageLine(im2, (int)x1, (int)y1, (int)x2, (int)y2, black);
		y1 = y2;
		x2 = width - margex;
		gdImageLine(im2, (int)x1, (int)y1, (int)x2, (int)y2, black);

	        x1=margex;
	        x2=x1+stepx;
	        y2=height-margey;
	}

	outf = fopen(file, "r");

	sprintf(file, "%s/index.html", outfile);
        outh = fopen(file, "w");
	fprintf(outh, "<html>\n<head><title>");
        if(strcmp(lang, "EN") == 0)
        	fprintf(outh, "Server statistics for %s", hostname);
        else
        	fprintf(outh, "Statistiques pour le  %s", hostname);
        fprintf(outh, "</title></head>\n");
       
	fprintf(outh, "<body bgcolor=\"#ffffff\" ");
	if (strcmp(background, "none") != 0)
		fprintf(outh, " background=\"%s\"", background);
	fprintf(outh, ">\n<h1><a NAME=\"Top\">");
	if (logoq && Gq)
		fprintf(outh, "<IMG src=\"%s\" alt=\"\"> ", logourl);
	if (hosturl[0] == '-') {
		if(strcmp(lang, "EN") == 0)
			fprintf(outh, "Server statistics</a> for %s", hostname);
		else
			fprintf(outh, "Statistiques pour le</a> %s", hostname);
		fprintf(outh, "</h1>\n\n");
	}
	else {
		if(strcmp(lang, "EN") == 0)
			fprintf(outh, "Server statistics</a> for ");
		else
			fprintf(outh, "Statistiques</a> pour le ");
		fprintf(outh, "<a HREF=\"%s\">%s</a></h1>\n\n", hosturl, hostname);
	}

	
	if(num_period == 1) {
        	fprintf(outh, "<p>\n<hr>\n<p>\n<b>");
        	if(strcmp(lang, "EN") == 0)
        		fprintf(outh, "Week of ");
        	else
        		fprintf(outh, "Semaine du ");
        	fprintf(outh, "<i>%s</i></b>\n<p>\n", firstperiod);
        }
	else {
        	fprintf(outh, "<p>\n<hr>\n<p>\n<b>");
        	if(strcmp(lang, "EN") == 0)
        		fprintf(outh, "Weeks from <i>%s</i> to <i>%s</i></b>\n<p>\n", firstperiod, lastperiod);
        	else
        		fprintf(outh, "Semaines du <i>%s</i> au <i>%s</i></b>\n<p>\n", firstperiod, lastperiod);
        }
        fprintf(outh, "<div align=\"center\">\n");
	if(Gq) {
        	if(strcmp(lang, "EN") == 0)
        		fprintf(outh, "<h3>Requests by weeks</h3>\n");
        	else
        		fprintf(outh, "<h3>Nombre de requ&ecirc;tes par semaine</h3>\n");
	        fprintf(outh, "<table border=\"1\">\n");
	        fprintf(outh, "<tr>\n");
       	 	fprintf(outh, "<td align=\"center\"><img src=\"images/cumul1.gif\">\n");
        	fprintf(outh, "</table>\n");
		if(strcmp(lang, "EN") == 0)
			fprintf(outh, "<p>\nMax requests : ");
		else
			fprintf(outh, "<p>\nNombre de requ&ecirc;tes max : ");
		int3printf(outh, max_reqs);
		if(strcmp(lang, "EN") == 0)
			fprintf(outh, ", week of <i>%02d/%02d/%d</i>\n", mon_max, date_max, year_max);
                else
			fprintf(outh, ", la semaine du <i>%02d/%02d/%d</i>\n", date_max, mon_max, year_max);
	}
        fprintf(outh, "</div>\n<p>\n");


	i = num_period - 1;
	num_date = 0;
	if(Gq) {
		color1 = gdImageColorAllocate(im1, 182, 242, 182);
		color2 = gdImageColorAllocate(im1, 75, 120, 75);
		color3 = gdImageColorAllocate(im2, 255, 0, 0);
		color4 = gdImageColorAllocate(im2, 0, 0, 255);
		xx11 = yy11 = xx21 = yy21 = 0;
		gdImageDashedLine(im2, margex, margey + tailley-(int)tailley*1/5, width-margex, margey + tailley-(int)tailley*1/5, black);
		gdImageDashedLine(im2, margex, margey + tailley-(int)tailley/2, width-margex, margey + tailley-(int)tailley/2, black);
		gdImageDashedLine(im2, margex, margey, width-margex, margey, black);
	}
	while(fgets(inputline, MAXLINELENGTH, outf) != NULL) {
		if(i < 100) {
			sscan_cum(inputline, &no_reqs, &no_hits, bytestr, bytestr_hits, &no_udp_reqs, udp_bytestr, &firstdate, &firstmon, &firstyear, &lastdate, &lastmon, &lastyear);
			no_bytes = atof(bytestr);
	                no_bytes_hits = atof(bytestr_hits);
			if(Gq) {
			y1 = margey + tailley-tailley*(float)(no_reqs+no_udp_reqs)/max_reqs;
	                gdImageFilledRectangle(im1, (int)x1, (int)y1, (int)x2, (int)y2, color1);
	                gdImageRectangle(im1, (int)x1, (int)y1, (int)x2, (int)y2, black);
			if(no_reqs>0)
				pc = (float)no_hits/no_reqs;
			else
				pc=0;
			if(pc*100 > max_hit_r) {
				max_hit_r = pc*100;
				mon_max_r = firstmon;
				year_max_r = firstyear;
				date_max_r = firstdate;
			}
			

			if(xx11 == 0 && yy11 == 0) {
				xx11 = x1;
				yy11 = margey + tailley-tailley*2*pc;
			}
			else {
				xx12 = x1;
				yy12 = margey + tailley-tailley*pc;
				gdImageLine(im2, (int)xx11, (int)yy11, (int)xx12, (int)yy12, color3);
				xx11 = xx12;
				yy11 = yy12;
			}

			if(no_bytes>0)
                                pc = no_bytes_hits/no_bytes;
                        else
                                pc=0;
                        if(pc*100 > max_hit_b) {
                                max_hit_b = pc*100;
                                mon_max_b = firstmon;
                                year_max_b = firstyear;
                                date_max_b = firstdate;
                        }

			if(xx21 == 0 && yy21 == 0) {
                                xx21 = x1;
                                yy21 = margey + tailley-tailley*pc;
                        }
                        else {
                                xx22 = x1;
                                yy22 = margey + tailley-tailley*pc;
                                gdImageLine(im2, (int)xx21, (int)yy21, (int)xx22, (int)yy22, color4);
                                xx21 = xx22;
                                yy21 = yy22;
                        }


			
	                x1 += stepx;
	                x2 += stepx;
			}
			sprintf(tab_date[i], "%d %d %d %d %d %d", firstdate, firstmon, firstyear, lastdate, lastmon, lastyear);
			num_date++;
		}
		i--;
	}

	fprintf(outh, "<div align=\"center\">\n");
        if(Gq) {
                if(strcmp(lang, "EN") == 0)
                	fprintf(outh, "<h3>Hits</h3>\n");
                else
                	fprintf(outh, "<h3>Taux de r&eacute;ussite</h3>\n");
                fprintf(outh, "<table border=\"1\">\n");
                fprintf(outh, "<tr>\n");
                fprintf(outh, "<td align=\"center\"><img src=\"images/cumul2.gif\">\n");
                fprintf(outh, "</table>\n");
		if(strcmp(lang, "EN") == 0)
			fprintf(outh, "<p>\nMax requests hit : ");
		else
			fprintf(outh, "<p>\nMeilleur taux de r&eacute;ussite en requ&ecirc;tes : ");
                double3printf(outh, max_hit_r);
                if(strcmp(lang, "EN") == 0)
                	fprintf(outh, "%%, week of <i>%02d/%02d/%d</i>\n", mon_max_r, date_max_r, year_max_r);
                else
                	fprintf(outh, "%%, la semaine du <i>%02d/%02d/%d</i>\n", date_max_r, mon_max_r, year_max_r);
                	
		if(strcmp(lang, "EN") == 0)
			fprintf(outh, "<p>\nMax bytes hit : ");
		else
			fprintf(outh, "<p>\nMeilleur taux de r&eacute;ussite en octets : ");
                double3printf(outh, max_hit_b);
                if(strcmp(lang, "EN") == 0)
                	fprintf(outh, "%%, week of <i>%02d/%02d/%d</i>\n", mon_max_b, date_max_b, year_max_b);
                else
                	fprintf(outh, "%%, la semaine du <i>%02d/%02d/%d</i>\n", date_max_b, mon_max_b, year_max_b);

        }
        fprintf(outh, "</div>\n<p>\n<hr>\n<p>\n");

	fclose(outf);
	if(Gq) {
/*
		gdImageFilledRectangle(im1, margex, height-10, margex + 5, height-5, color1);
		gdImageRectangle(im1, margex, height-10, margex + 5, height-5, black);
		sprintf(s, "#reqs total");
		gdImageString(im1, gdFontSmall, margex + 10, height-12, s, black);
		gdImageFilledRectangle(im1, width/2 + margex, height-10, width/2 + margex+ 5, height-5, color2);
		gdImageRectangle(im1, width/2 + margex, height-10, width/2 + margex + 5, height-5, black);
		sprintf(s, "#reqs dans le cache");
		gdImageString(im1, gdFontSmall, width/2 + margex + 10, height-12, s, black);

*/
		gdImageLine(im2, margex, height-7,  margex + 10, height-7, color3);
		sprintf(s, "%%reqs_hit");
		gdImageString(im2, gdFontSmall, margex + 15, height-12, s, black);
		gdImageLine(im2, width/2 + margex, height-7,  width/2 + margex+ 10, height-7, color4);
		sprintf(s, "%%bytes_hit");
		gdImageString(im2, gdFontSmall, width/2 + margex + 15, height-12, s, black);

		sprintf(s, "20%%");
		gdImageString(im2, gdFontSmall, 0, margey + tailley-(int)tailley*1/5 - 2, s, black);
		sprintf(s, "50%%");
		gdImageString(im2, gdFontSmall, 0, margey - 2 + tailley/2, s, black);
		sprintf(s, "100%%");
		gdImageString(im2, gdFontSmall, 0, margey - 2, s, black);

		sprintf(file, "%s/images/cumul1.gif", outfile);
       	 	outi1 = fopen(file, "wb");
		sprintf(file, "%s/images/cumul2.gif", outfile);
                outi2 = fopen(file, "wb");


        	gdImageGif(im1, outi1);
        	gdImageGif(im2, outi2);
        	fclose(outi1);
        	fclose(outi2);
        	gdImageDestroy(im1);
        	gdImageDestroy(im2);
	}

	j = 0;
	fprintf(outh, "<div align=\"center\">\n <table width=\"100%%\" border=\"0\">\n");
	for(i = 0; i < num_date; i++) {
		sscanf(tab_date[i], "%d %d %d %d %d %d", &firstdate, &firstmon, &firstyear , &lastdate, &lastmon, &lastyear);
		if (j == 0) {
			fprintf(outh, "<tr>\n");
			j = 1;
		}
		else j = 0;
		fprintf(outh, "<td align=\"center\"><a href=\"stat%d.%02d.%02d.html\">", firstyear, firstmon, firstdate);
		if(strcmp(lang, "EN") == 0)
			fprintf(outh, "Week from %02d/%02d/%d to %02d/%02d/%d</a><br>\n",
				firstmon, firstdate, firstyear, lastmon, lastdate, lastyear);
		else
			fprintf(outh, "%d : Semaine du %02d/%02d/%d au %02d/%02d/%d</a><br>\n",
				i+1, firstdate, firstmon, firstyear, lastdate, lastmon, lastyear);
		
	}
	fprintf(outh, "\n</table>\n</div>");
	if(strcmp(lang, "EN") == 0)
		fprintf(outh, "\n<hr>\n<i>Generated by <a href=\"http://cache.cnrs.fr/prostat/\">prostat v%s</a></i>.", version);
	else
		fprintf(outh, "\n<hr>\n<i>Produit par <a href=\"http://cache.cnrs.fr/prostat/\">prostat v%s</a></i>.", version);
	fprintf(outh, "</body>\n</html>\n");
	fclose(outh);
	
}

int sscan_cum(char *inputline, int *tcp_reqs, int *no_hits, char bytestr[16], char bytestr_hits[16], int *udp_reqs, char udp_bytestr[16], int *firstdate, int *firstmon, 
	int *firstyear, int *lastdate, int *lastmon, int *lastyear)
{
	char *cin = inputline;   /* the character we are reading */
  	char *cout;              /* where we are putting it */
  	int i;
	char champ[100];

	i = 0;
	for (cout = champ; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
       		cin++) {
    		*cout = *cin;
    		cout++;
    		i++;
  	}
	if (*cin != ':') return(1);
	*cout = '\0';

	i = 0;
	cin++;
        for (cout = champ; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(2);
        *cout = '\0';
	*tcp_reqs = atoi(champ);

	i = 0;
	cin++;
        for (cout = champ; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(3);
        *cout = '\0';
	*no_hits = atoi(champ);
	
	i = 0;
        cin++;
        for (cout = champ; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(4);
        *cout = '\0';
	*udp_reqs = atoi(champ);

	i = 0;
        cin++;
        for (cout = bytestr; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(5);
        *cout = '\0';

	i = 0;
        cin++;
        for (cout = bytestr_hits; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(6);
        *cout = '\0';

	i = 0;
        cin++;
        for (cout = udp_bytestr; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(7);
        *cout = '\0';

	i = 0;
        cin++;
        for (cout = champ; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(7);
        *cout = '\0';


	i = 0;
        cin++;
        for (cout = champ; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ' ') return(8);
        *cout = '\0';
	*firstdate = atoi(champ);

	i = 0;
        cin++;
        for (cout = champ; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ' ') return(9);
        *cout = '\0';
	*firstmon = atoi(champ);
	
	i = 0;
        cin++;
        for (cout = champ; *cin != ':' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ':') return(10);
        *cout = '\0';
	*firstyear = atoi(champ);

	i = 0;
        cin++;
        for (cout = champ; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ' ') return(11);
        *cout = '\0';
        *lastdate = atoi(champ);

	i = 0;
        cin++;
        for (cout = champ; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != ' ') return(12);
        *cout = '\0';
	*lastmon = atoi(champ);
	
	i = 0;
        cin++;
        for (cout = champ; *cin != '\n' && *cin != '\0' && i < 99;
                cin++) {
                *cout = *cin;
                cout++;
                i++;
        }
        if (*cin != '\0' && *cin != '\n') return(13);
        *cout = '\0';
        *lastyear = atoi(champ);

	return(0);
}

